/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/calibration_msgs/msg/CameraMeasurement.msg.  Do not edit! */
#ifndef CALIBRATION_MSGS_CAMERAMEASUREMENT_H
#define CALIBRATION_MSGS_CAMERAMEASUREMENT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "calibration_msgs/ImagePoint.h"
#include "sensor_msgs/RegionOfInterest.h"
#include "sensor_msgs/CameraInfo.h"
#include "sensor_msgs/Image.h"
#include "geometry_msgs/Point32.h"
#include "calibration_msgs/CalibrationPattern.h"

namespace calibration_msgs
{

//! \htmlinclude CameraMeasurement.msg.html

class CameraMeasurement : public ros::Message
{
public:
  typedef boost::shared_ptr<CameraMeasurement> Ptr;
  typedef boost::shared_ptr<CameraMeasurement const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _camera_id_type;
  typedef std::vector<calibration_msgs::ImagePoint> _image_points_type;
  typedef sensor_msgs::CameraInfo _cam_info_type;
  typedef uint8_t _verbose_type;
  typedef sensor_msgs::Image _image_type;
  typedef sensor_msgs::Image _image_rect_type;
  typedef calibration_msgs::CalibrationPattern _features_type;

  roslib::Header header;
  std::string camera_id;
  std::vector<calibration_msgs::ImagePoint> image_points;
  sensor_msgs::CameraInfo cam_info;
  uint8_t verbose;
  sensor_msgs::Image image;
  sensor_msgs::Image image_rect;
  calibration_msgs::CalibrationPattern features;

  CameraMeasurement() : ros::Message(),
    verbose(0)
  {
  }
  CameraMeasurement(const CameraMeasurement &copy) : ros::Message(),
    header(copy.header),
    camera_id(copy.camera_id),
    cam_info(copy.cam_info),
    verbose(copy.verbose),
    image(copy.image),
    image_rect(copy.image_rect),
    features(copy.features)
  {
    (void)copy;
    image_points = copy.image_points;
  }
  CameraMeasurement &operator =(const CameraMeasurement &copy)
  {
    if (this == &copy)
      return *this;
    image_points.clear();
    header = copy.header;
    camera_id = copy.camera_id;
    image_points = copy.image_points;
    cam_info = copy.cam_info;
    verbose = copy.verbose;
    image = copy.image;
    image_rect = copy.image_rect;
    features = copy.features;
    return *this;
  }
  virtual ~CameraMeasurement() 
  {
    image_points.clear();
  }
  inline static std::string __s_getDataType() { return std::string("calibration_msgs/CameraMeasurement"); }
  inline static std::string __s_getMD5Sum() { return std::string("090b0673159d7e94e15e007f839bb70d"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "Header header\n"
    "string camera_id\n"
    "ImagePoint[] image_points\n"
    "sensor_msgs/CameraInfo cam_info\n"
    "\n"
    "# True -> The extra debugging fields are populated\n"
    "bool verbose\n"
    "\n"
    "# Extra, partially processed data. Only needed for debugging\n"
    "sensor_msgs/Image image\n"
    "sensor_msgs/Image image_rect\n"
    "calibration_msgs/CalibrationPattern features\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/ImagePoint\n"
    "float32 x\n"
    "float32 y\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/CameraInfo\n"
    "# This message defines meta information for a camera. It should be in a\n"
    "# camera namespace and accompanied by up to 5 image topics named:\n"
    "# \n"
    "# image_raw, image, image_color, image_rect, and image_rect_color\n"
    "#\n"
    "# The meaning of the camera parameters are described in detail at\n"
    "# http://pr.willowgarage.com/wiki/Camera_Calibration.\n"
    "\n"
    "##########################\n"
    "# Image acquisition info #\n"
    "##########################\n"
    "\n"
    "# Time of image acquisition, camera coordinate frame ID\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of camera\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "\n"
    "# Camera resolution in pixels\n"
    "uint32 height\n"
    "uint32 width\n"
    "\n"
    "# Region of interest (subwindow of full camera resolution), if applicable\n"
    "RegionOfInterest roi\n"
    "\n"
    "##########################################\n"
    "# Internal parameters                    #\n"
    "# Used for warping to:                   #\n"
    "#  1. An undistorted image (just D and K)#\n"
    "#  2. A rectified image (D, K, R)        #\n"
    "# Users should not normally need these   #\n"
    "##########################################\n"
    "\n"
    "# Distortion parameters: k1, k2, t1, t2, k3\n"
    "# These model radial and tangential distortion of the camera.\n"
    "float64[5]  D # 5x1 vector\n"
    "\n"
    "# Intrinsic camera matrix for the raw (distorted) images\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#     [fx  0 cx]\n"
    "# K = [ 0 fy cy]\n"
    "#     [ 0  0  1]\n"
    "\n"
    "float64[9]  K # 3x3 row-major matrix\n"
    "\n"
    "\n"
    "# Rectification matrix (stereo cameras only)\n"
    "# A homography which takes an image to the ideal stereo image plane\n"
    "# so that epipolar lines in both stereo images are parallel.\n"
    "float64[9]  R # 3x3 row-major matrix\n"
    "\n"
    "######################################\n"
    "# Projection/camera matrix           #\n"
    "# This is a 3x4 projection matrix    #\n"
    "#   for going from 3D to 2D coords   #\n"
    "######################################\n"
    "\n"
    "# Projection/camera matrix\n"
    "# By convention, this matrix specifies the intrinsic (camera)\n"
    "#   matrix of the processed (rectified) image.\n"
    "# Upper 3x3 portion is the normal camera intrinsic matrix for\n"
    "#   the rectified image\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#              [fx  0 cx]\n"
    "# P[1:3,1:3] = [ 0 fy cy]\n"
    "#              [ 0  0  1]\n"
    "# For the right camera of a stereo pair, P[4,1] is the position\n"
    "#  of the right camera center in the left camera's frame, times\n"
    "#  the focal length fx.\n"
    "# \n"
    "# Given a 3D point q=[XYZ]^T in the left camera frame, the projection\n"
    "#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.\n"
    "#  This holds for both left and right images of a stereo pair.  \n"
    "#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.\n"
    "\n"
    "float64[12] P # 3x4 row-major matrix\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/RegionOfInterest\n"
    "# This message is used to specify a region of interest within an image\n"
    "#\n"
    "# When used to specify the ROI setting of the camera when the image was taken,\n"
    "# the height and width fields should either match the height and width\n"
    "# fields for the associated image or be zeroes to indicate that the full image\n"
    "# was captured\n"
    "\n"
    "uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)\n"
    "uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)\n"
    "uint32 height    #Height of ROI\n"
    "uint32 width     #Width of ROI\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/Image\n"
    "# This message contains an uncompressed image\n"
    "# (0, 0) is at top-left corner of image\n"
    "#\n"
    "\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of cameara\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "                     # If the frame_id here and the frame_id of the CameraInfo\n"
    "                     # message associated with the image conflict\n"
    "                     # the behavior is undefined\n"
    "\n"
    "uint32 height         # image height, that is, number of rows\n"
    "uint32 width          # image width, that is, number of columns\n"
    "\n"
    "# The legal values for encoding are in file src/image_encodings.cpp\n"
    "# If you want to standardize a new string format, join\n"
    "# ros-users@lists.sourceforge.net and send an email proposing a new encoding.\n"
    "\n"
    "string encoding       # Encoding of pixels -- channel meaning, ordering, size\n"
    "                      # taken from the list of strings in src/image_encodings.cpp\n"
    "\n"
    "uint8 is_bigendian    # is this data bigendian?\n"
    "uint32 step           # Full row length in bytes\n"
    "uint8[] data          # actual matrix data, size is (step * rows)\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/CalibrationPattern\n"
    "Header header\n"
    "geometry_msgs/Point32[] object_points\n"
    "ImagePoint[] image_points\n"
    "uint8 success\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_image_points_size(uint32_t __ros_new_size)
  {
    this->image_points.resize(__ros_new_size);
  }
  inline uint32_t get_image_points_size() const { return image_points.size(); }
  inline void get_image_points_vec (std::vector<calibration_msgs::ImagePoint> &__ros_vec) const
  {
    __ros_vec = this->image_points;
  }
  inline void set_image_points_vec(const std::vector<calibration_msgs::ImagePoint> &__ros_vec)
  {
    this->image_points = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + camera_id.length(); // camera_id
    __l += 4 + (image_points.size() ? image_points.size() * image_points[0].serializationLength() : 0); // image_points
    __l += cam_info.serializationLength(); // cam_info
    __l += 1; // verbose
    __l += image.serializationLength(); // image
    __l += image_rect.serializationLength(); // image_rect
    __l += features.serializationLength(); // features
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_camera_id_len = camera_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_camera_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, camera_id.c_str(), __ros_camera_id_len);
    uint32_t __image_points_size = image_points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __image_points_size);
    for (size_t i = 0; i < __image_points_size; i++)
      write_ptr = image_points[i].serialize(write_ptr, seq);
    write_ptr = cam_info.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, verbose);
    write_ptr = image.serialize(write_ptr, seq);
    write_ptr = image_rect.serialize(write_ptr, seq);
    write_ptr = features.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_camera_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_camera_id_len);
    camera_id = std::string((const char *)read_ptr, __ros_camera_id_len);
    read_ptr += __ros_camera_id_len;
    uint32_t __image_points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __image_points_size);
    set_image_points_size(__image_points_size);
    for (size_t i = 0; i < __image_points_size; i++)
      read_ptr = image_points[i].deserialize(read_ptr);
    read_ptr = cam_info.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, verbose);
    read_ptr = image.deserialize(read_ptr);
    read_ptr = image_rect.deserialize(read_ptr);
    read_ptr = features.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<CameraMeasurement> CameraMeasurementPtr;
typedef boost::shared_ptr<CameraMeasurement const> CameraMeasurementConstPtr;


}

#endif
