/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/calibration_msgs/msg/LaserMeasurement.msg.  Do not edit! */
#ifndef CALIBRATION_MSGS_LASERMEASUREMENT_H
#define CALIBRATION_MSGS_LASERMEASUREMENT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/JointState.h"
#include "calibration_msgs/DenseLaserSnapshot.h"
#include "sensor_msgs/Image.h"
#include "geometry_msgs/Point32.h"
#include "calibration_msgs/ImagePoint.h"
#include "calibration_msgs/CalibrationPattern.h"
#include "calibration_msgs/JointStateCalibrationPattern.h"

namespace calibration_msgs
{

//! \htmlinclude LaserMeasurement.msg.html

class LaserMeasurement : public ros::Message
{
public:
  typedef boost::shared_ptr<LaserMeasurement> Ptr;
  typedef boost::shared_ptr<LaserMeasurement const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _laser_id_type;
  typedef std::vector<sensor_msgs::JointState> _joint_points_type;
  typedef uint8_t _verbose_type;
  typedef calibration_msgs::DenseLaserSnapshot _snapshot_type;
  typedef sensor_msgs::Image _laser_image_type;
  typedef calibration_msgs::CalibrationPattern _image_features_type;
  typedef calibration_msgs::JointStateCalibrationPattern _joint_features_type;

  roslib::Header header;
  std::string laser_id;
  std::vector<sensor_msgs::JointState> joint_points;
  uint8_t verbose;
  calibration_msgs::DenseLaserSnapshot snapshot;
  sensor_msgs::Image laser_image;
  calibration_msgs::CalibrationPattern image_features;
  calibration_msgs::JointStateCalibrationPattern joint_features;

  LaserMeasurement() : ros::Message(),
    verbose(0)
  {
  }
  LaserMeasurement(const LaserMeasurement &copy) : ros::Message(),
    header(copy.header),
    laser_id(copy.laser_id),
    verbose(copy.verbose),
    snapshot(copy.snapshot),
    laser_image(copy.laser_image),
    image_features(copy.image_features),
    joint_features(copy.joint_features)
  {
    (void)copy;
    joint_points = copy.joint_points;
  }
  LaserMeasurement &operator =(const LaserMeasurement &copy)
  {
    if (this == &copy)
      return *this;
    joint_points.clear();
    header = copy.header;
    laser_id = copy.laser_id;
    joint_points = copy.joint_points;
    verbose = copy.verbose;
    snapshot = copy.snapshot;
    laser_image = copy.laser_image;
    image_features = copy.image_features;
    joint_features = copy.joint_features;
    return *this;
  }
  virtual ~LaserMeasurement() 
  {
    joint_points.clear();
  }
  inline static std::string __s_getDataType() { return std::string("calibration_msgs/LaserMeasurement"); }
  inline static std::string __s_getMD5Sum() { return std::string("03ce2d57df2a0cedc1a91dc4b40d7729"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "Header header\n"
    "string laser_id\n"
    "sensor_msgs/JointState[] joint_points\n"
    "\n"
    "# True -> The extra debugging fields are populated\n"
    "bool verbose\n"
    "\n"
    "# Extra, partially processed data. Only needed for debugging\n"
    "calibration_msgs/DenseLaserSnapshot snapshot\n"
    "sensor_msgs/Image laser_image\n"
    "calibration_msgs/CalibrationPattern image_features\n"
    "calibration_msgs/JointStateCalibrationPattern joint_features\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/DenseLaserSnapshot\n"
    "# Provides all the state & sensor information for\n"
    "# a single sweep of laser attached to some mechanism.\n"
    "# Most likely, this will be used with PR2's tilting laser mechanism\n"
    "Header header\n"
    "\n"
    "# Store the laser intrinsics. This is very similar to the\n"
    "# intrinsics commonly stored in \n"
    "float32 angle_min        # start angle of the scan [rad]\n"
    "float32 angle_max        # end angle of the scan [rad]\n"
    "float32 angle_increment  # angular distance between measurements [rad]\n"
    "float32 time_increment   # time between measurements [seconds]\n"
    "float32 range_min        # minimum range value [m]\n"
    "float32 range_max        # maximum range value [m]\n"
    "\n"
    "# Define the size of the binary data\n"
    "uint32 readings_per_scan    # (Width)\n"
    "uint32 num_scans            # (Height)\n"
    "\n"
    "# 2D Arrays storing laser data.\n"
    "# We can think of each type data as being a single channel image.\n"
    "# Each row of the image has data from a single scan, and scans are\n"
    "# concatenated to form the entire 'image'.\n"
    "float32[] ranges            # (Image data)\n"
    "float32[] intensities       # (Image data)\n"
    "\n"
    "# Store the start time of each scan\n"
    "time[] scan_start\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/Image\n"
    "# This message contains an uncompressed image\n"
    "# (0, 0) is at top-left corner of image\n"
    "#\n"
    "\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of cameara\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "                     # If the frame_id here and the frame_id of the CameraInfo\n"
    "                     # message associated with the image conflict\n"
    "                     # the behavior is undefined\n"
    "\n"
    "uint32 height         # image height, that is, number of rows\n"
    "uint32 width          # image width, that is, number of columns\n"
    "\n"
    "# The legal values for encoding are in file src/image_encodings.cpp\n"
    "# If you want to standardize a new string format, join\n"
    "# ros-users@lists.sourceforge.net and send an email proposing a new encoding.\n"
    "\n"
    "string encoding       # Encoding of pixels -- channel meaning, ordering, size\n"
    "                      # taken from the list of strings in src/image_encodings.cpp\n"
    "\n"
    "uint8 is_bigendian    # is this data bigendian?\n"
    "uint32 step           # Full row length in bytes\n"
    "uint8[] data          # actual matrix data, size is (step * rows)\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/CalibrationPattern\n"
    "Header header\n"
    "geometry_msgs/Point32[] object_points\n"
    "ImagePoint[] image_points\n"
    "uint8 success\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "================================================================================\n"
    "MSG: calibration_msgs/ImagePoint\n"
    "float32 x\n"
    "float32 y\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/JointStateCalibrationPattern\n"
    "Header header\n"
    "geometry_msgs/Point32[]  object_points\n"
    "sensor_msgs/JointState[] joint_points\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_joint_points_size(uint32_t __ros_new_size)
  {
    this->joint_points.resize(__ros_new_size);
  }
  inline uint32_t get_joint_points_size() const { return joint_points.size(); }
  uint32_t calc_joint_points_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_points_size = joint_points.size();
    for (size_t i = 0; i < joint_points_size; i++)
      l += joint_points[i].serializationLength();
    return l;
  }
  inline void get_joint_points_vec (std::vector<sensor_msgs::JointState> &__ros_vec) const
  {
    __ros_vec = this->joint_points;
  }
  inline void set_joint_points_vec(const std::vector<sensor_msgs::JointState> &__ros_vec)
  {
    this->joint_points = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + laser_id.length(); // laser_id
    __l += 4 + calc_joint_points_array_serialization_len(); // joint_points
    __l += 1; // verbose
    __l += snapshot.serializationLength(); // snapshot
    __l += laser_image.serializationLength(); // laser_image
    __l += image_features.serializationLength(); // image_features
    __l += joint_features.serializationLength(); // joint_features
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_laser_id_len = laser_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_laser_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, laser_id.c_str(), __ros_laser_id_len);
    uint32_t __joint_points_size = joint_points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_points_size);
    for (size_t i = 0; i < __joint_points_size; i++)
      write_ptr = joint_points[i].serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, verbose);
    write_ptr = snapshot.serialize(write_ptr, seq);
    write_ptr = laser_image.serialize(write_ptr, seq);
    write_ptr = image_features.serialize(write_ptr, seq);
    write_ptr = joint_features.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_laser_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_laser_id_len);
    laser_id = std::string((const char *)read_ptr, __ros_laser_id_len);
    read_ptr += __ros_laser_id_len;
    uint32_t __joint_points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_points_size);
    set_joint_points_size(__joint_points_size);
    for (size_t i = 0; i < __joint_points_size; i++)
      read_ptr = joint_points[i].deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, verbose);
    read_ptr = snapshot.deserialize(read_ptr);
    read_ptr = laser_image.deserialize(read_ptr);
    read_ptr = image_features.deserialize(read_ptr);
    read_ptr = joint_features.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<LaserMeasurement> LaserMeasurementPtr;
typedef boost::shared_ptr<LaserMeasurement const> LaserMeasurementConstPtr;


}

#endif
