/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/calibration_msgs/msg/RobotMeasurement.msg.  Do not edit! */
#ifndef CALIBRATION_MSGS_ROBOTMEASUREMENT_H
#define CALIBRATION_MSGS_ROBOTMEASUREMENT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "calibration_msgs/ImagePoint.h"
#include "sensor_msgs/RegionOfInterest.h"
#include "sensor_msgs/CameraInfo.h"
#include "sensor_msgs/Image.h"
#include "geometry_msgs/Point32.h"
#include "calibration_msgs/CalibrationPattern.h"
#include "calibration_msgs/CameraMeasurement.h"
#include "sensor_msgs/JointState.h"
#include "calibration_msgs/DenseLaserSnapshot.h"
#include "calibration_msgs/JointStateCalibrationPattern.h"
#include "calibration_msgs/LaserMeasurement.h"
#include "calibration_msgs/ChainMeasurement.h"

namespace calibration_msgs
{

//! \htmlinclude RobotMeasurement.msg.html

class RobotMeasurement : public ros::Message
{
public:
  typedef boost::shared_ptr<RobotMeasurement> Ptr;
  typedef boost::shared_ptr<RobotMeasurement const> ConstPtr;

  typedef std::string _sample_id_type;
  typedef std::string _target_id_type;
  typedef std::string _chain_id_type;
  typedef std::vector<calibration_msgs::CameraMeasurement> _M_cam_type;
  typedef std::vector<calibration_msgs::LaserMeasurement> _M_laser_type;
  typedef std::vector<calibration_msgs::ChainMeasurement> _M_chain_type;

  std::string sample_id;
  std::string target_id;
  std::string chain_id;
  std::vector<calibration_msgs::CameraMeasurement> M_cam;
  std::vector<calibration_msgs::LaserMeasurement> M_laser;
  std::vector<calibration_msgs::ChainMeasurement> M_chain;

  RobotMeasurement() : ros::Message()
  {
  }
  RobotMeasurement(const RobotMeasurement &copy) : ros::Message(),
    sample_id(copy.sample_id),
    target_id(copy.target_id),
    chain_id(copy.chain_id)
  {
    (void)copy;
    M_cam = copy.M_cam;
    M_laser = copy.M_laser;
    M_chain = copy.M_chain;
  }
  RobotMeasurement &operator =(const RobotMeasurement &copy)
  {
    if (this == &copy)
      return *this;
    M_cam.clear();
    M_laser.clear();
    M_chain.clear();
    sample_id = copy.sample_id;
    target_id = copy.target_id;
    chain_id = copy.chain_id;
    M_cam = copy.M_cam;
    M_laser = copy.M_laser;
    M_chain = copy.M_chain;
    return *this;
  }
  virtual ~RobotMeasurement() 
  {
    M_cam.clear();
    M_laser.clear();
    M_chain.clear();
  }
  inline static std::string __s_getDataType() { return std::string("calibration_msgs/RobotMeasurement"); }
  inline static std::string __s_getMD5Sum() { return std::string("a678b901730e88bab47546163d96aa5b"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "string sample_id    # Tag to figure out which yaml file this was generated from\n"
    "\n"
    "string target_id    # Defines the target that we were sensing.\n"
    "string chain_id     # Defines where this target was attached\n"
    "\n"
    "CameraMeasurement[] M_cam\n"
    "LaserMeasurement[]  M_laser\n"
    "ChainMeasurement[]  M_chain\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/CameraMeasurement\n"
    "Header header\n"
    "string camera_id\n"
    "ImagePoint[] image_points\n"
    "sensor_msgs/CameraInfo cam_info\n"
    "\n"
    "# True -> The extra debugging fields are populated\n"
    "bool verbose\n"
    "\n"
    "# Extra, partially processed data. Only needed for debugging\n"
    "sensor_msgs/Image image\n"
    "sensor_msgs/Image image_rect\n"
    "calibration_msgs/CalibrationPattern features\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/ImagePoint\n"
    "float32 x\n"
    "float32 y\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/CameraInfo\n"
    "# This message defines meta information for a camera. It should be in a\n"
    "# camera namespace and accompanied by up to 5 image topics named:\n"
    "# \n"
    "# image_raw, image, image_color, image_rect, and image_rect_color\n"
    "#\n"
    "# The meaning of the camera parameters are described in detail at\n"
    "# http://pr.willowgarage.com/wiki/Camera_Calibration.\n"
    "\n"
    "##########################\n"
    "# Image acquisition info #\n"
    "##########################\n"
    "\n"
    "# Time of image acquisition, camera coordinate frame ID\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of camera\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "\n"
    "# Camera resolution in pixels\n"
    "uint32 height\n"
    "uint32 width\n"
    "\n"
    "# Region of interest (subwindow of full camera resolution), if applicable\n"
    "RegionOfInterest roi\n"
    "\n"
    "##########################################\n"
    "# Internal parameters                    #\n"
    "# Used for warping to:                   #\n"
    "#  1. An undistorted image (just D and K)#\n"
    "#  2. A rectified image (D, K, R)        #\n"
    "# Users should not normally need these   #\n"
    "##########################################\n"
    "\n"
    "# Distortion parameters: k1, k2, t1, t2, k3\n"
    "# These model radial and tangential distortion of the camera.\n"
    "float64[5]  D # 5x1 vector\n"
    "\n"
    "# Intrinsic camera matrix for the raw (distorted) images\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#     [fx  0 cx]\n"
    "# K = [ 0 fy cy]\n"
    "#     [ 0  0  1]\n"
    "\n"
    "float64[9]  K # 3x3 row-major matrix\n"
    "\n"
    "\n"
    "# Rectification matrix (stereo cameras only)\n"
    "# A homography which takes an image to the ideal stereo image plane\n"
    "# so that epipolar lines in both stereo images are parallel.\n"
    "float64[9]  R # 3x3 row-major matrix\n"
    "\n"
    "######################################\n"
    "# Projection/camera matrix           #\n"
    "# This is a 3x4 projection matrix    #\n"
    "#   for going from 3D to 2D coords   #\n"
    "######################################\n"
    "\n"
    "# Projection/camera matrix\n"
    "# By convention, this matrix specifies the intrinsic (camera)\n"
    "#   matrix of the processed (rectified) image.\n"
    "# Upper 3x3 portion is the normal camera intrinsic matrix for\n"
    "#   the rectified image\n"
    "# Projects 3D points in the camera coordinate frame to 2D pixel\n"
    "# coordinates using the focal lengths (fx, fy) and principal point\n"
    "# (cx, cy):\n"
    "#              [fx  0 cx]\n"
    "# P[1:3,1:3] = [ 0 fy cy]\n"
    "#              [ 0  0  1]\n"
    "# For the right camera of a stereo pair, P[4,1] is the position\n"
    "#  of the right camera center in the left camera's frame, times\n"
    "#  the focal length fx.\n"
    "# \n"
    "# Given a 3D point q=[XYZ]^T in the left camera frame, the projection\n"
    "#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.\n"
    "#  This holds for both left and right images of a stereo pair.  \n"
    "#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.\n"
    "\n"
    "float64[12] P # 3x4 row-major matrix\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/RegionOfInterest\n"
    "# This message is used to specify a region of interest within an image\n"
    "#\n"
    "# When used to specify the ROI setting of the camera when the image was taken,\n"
    "# the height and width fields should either match the height and width\n"
    "# fields for the associated image or be zeroes to indicate that the full image\n"
    "# was captured\n"
    "\n"
    "uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)\n"
    "uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)\n"
    "uint32 height    #Height of ROI\n"
    "uint32 width     #Width of ROI\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/Image\n"
    "# This message contains an uncompressed image\n"
    "# (0, 0) is at top-left corner of image\n"
    "#\n"
    "\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of cameara\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "                     # If the frame_id here and the frame_id of the CameraInfo\n"
    "                     # message associated with the image conflict\n"
    "                     # the behavior is undefined\n"
    "\n"
    "uint32 height         # image height, that is, number of rows\n"
    "uint32 width          # image width, that is, number of columns\n"
    "\n"
    "# The legal values for encoding are in file src/image_encodings.cpp\n"
    "# If you want to standardize a new string format, join\n"
    "# ros-users@lists.sourceforge.net and send an email proposing a new encoding.\n"
    "\n"
    "string encoding       # Encoding of pixels -- channel meaning, ordering, size\n"
    "                      # taken from the list of strings in src/image_encodings.cpp\n"
    "\n"
    "uint8 is_bigendian    # is this data bigendian?\n"
    "uint32 step           # Full row length in bytes\n"
    "uint8[] data          # actual matrix data, size is (step * rows)\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/CalibrationPattern\n"
    "Header header\n"
    "geometry_msgs/Point32[] object_points\n"
    "ImagePoint[] image_points\n"
    "uint8 success\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "================================================================================\n"
    "MSG: calibration_msgs/LaserMeasurement\n"
    "Header header\n"
    "string laser_id\n"
    "sensor_msgs/JointState[] joint_points\n"
    "\n"
    "# True -> The extra debugging fields are populated\n"
    "bool verbose\n"
    "\n"
    "# Extra, partially processed data. Only needed for debugging\n"
    "calibration_msgs/DenseLaserSnapshot snapshot\n"
    "sensor_msgs/Image laser_image\n"
    "calibration_msgs/CalibrationPattern image_features\n"
    "calibration_msgs/JointStateCalibrationPattern joint_features\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/DenseLaserSnapshot\n"
    "# Provides all the state & sensor information for\n"
    "# a single sweep of laser attached to some mechanism.\n"
    "# Most likely, this will be used with PR2's tilting laser mechanism\n"
    "Header header\n"
    "\n"
    "# Store the laser intrinsics. This is very similar to the\n"
    "# intrinsics commonly stored in \n"
    "float32 angle_min        # start angle of the scan [rad]\n"
    "float32 angle_max        # end angle of the scan [rad]\n"
    "float32 angle_increment  # angular distance between measurements [rad]\n"
    "float32 time_increment   # time between measurements [seconds]\n"
    "float32 range_min        # minimum range value [m]\n"
    "float32 range_max        # maximum range value [m]\n"
    "\n"
    "# Define the size of the binary data\n"
    "uint32 readings_per_scan    # (Width)\n"
    "uint32 num_scans            # (Height)\n"
    "\n"
    "# 2D Arrays storing laser data.\n"
    "# We can think of each type data as being a single channel image.\n"
    "# Each row of the image has data from a single scan, and scans are\n"
    "# concatenated to form the entire 'image'.\n"
    "float32[] ranges            # (Image data)\n"
    "float32[] intensities       # (Image data)\n"
    "\n"
    "# Store the start time of each scan\n"
    "time[] scan_start\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/JointStateCalibrationPattern\n"
    "Header header\n"
    "geometry_msgs/Point32[]  object_points\n"
    "sensor_msgs/JointState[] joint_points\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/ChainMeasurement\n"
    "Header header\n"
    "string chain_id\n"
    "sensor_msgs/JointState chain_state\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_M_cam_size(uint32_t __ros_new_size)
  {
    this->M_cam.resize(__ros_new_size);
  }
  inline uint32_t get_M_cam_size() const { return M_cam.size(); }
  uint32_t calc_M_cam_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t M_cam_size = M_cam.size();
    for (size_t i = 0; i < M_cam_size; i++)
      l += M_cam[i].serializationLength();
    return l;
  }
  inline void get_M_cam_vec (std::vector<calibration_msgs::CameraMeasurement> &__ros_vec) const
  {
    __ros_vec = this->M_cam;
  }
  inline void set_M_cam_vec(const std::vector<calibration_msgs::CameraMeasurement> &__ros_vec)
  {
    this->M_cam = __ros_vec;
  }
  void set_M_laser_size(uint32_t __ros_new_size)
  {
    this->M_laser.resize(__ros_new_size);
  }
  inline uint32_t get_M_laser_size() const { return M_laser.size(); }
  uint32_t calc_M_laser_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t M_laser_size = M_laser.size();
    for (size_t i = 0; i < M_laser_size; i++)
      l += M_laser[i].serializationLength();
    return l;
  }
  inline void get_M_laser_vec (std::vector<calibration_msgs::LaserMeasurement> &__ros_vec) const
  {
    __ros_vec = this->M_laser;
  }
  inline void set_M_laser_vec(const std::vector<calibration_msgs::LaserMeasurement> &__ros_vec)
  {
    this->M_laser = __ros_vec;
  }
  void set_M_chain_size(uint32_t __ros_new_size)
  {
    this->M_chain.resize(__ros_new_size);
  }
  inline uint32_t get_M_chain_size() const { return M_chain.size(); }
  uint32_t calc_M_chain_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t M_chain_size = M_chain.size();
    for (size_t i = 0; i < M_chain_size; i++)
      l += M_chain[i].serializationLength();
    return l;
  }
  inline void get_M_chain_vec (std::vector<calibration_msgs::ChainMeasurement> &__ros_vec) const
  {
    __ros_vec = this->M_chain;
  }
  inline void set_M_chain_vec(const std::vector<calibration_msgs::ChainMeasurement> &__ros_vec)
  {
    this->M_chain = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + sample_id.length(); // sample_id
    __l += 4 + target_id.length(); // target_id
    __l += 4 + chain_id.length(); // chain_id
    __l += 4 + calc_M_cam_array_serialization_len(); // M_cam
    __l += 4 + calc_M_laser_array_serialization_len(); // M_laser
    __l += 4 + calc_M_chain_array_serialization_len(); // M_chain
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_sample_id_len = sample_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_sample_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, sample_id.c_str(), __ros_sample_id_len);
    unsigned __ros_target_id_len = target_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_target_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, target_id.c_str(), __ros_target_id_len);
    unsigned __ros_chain_id_len = chain_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_chain_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, chain_id.c_str(), __ros_chain_id_len);
    uint32_t __M_cam_size = M_cam.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __M_cam_size);
    for (size_t i = 0; i < __M_cam_size; i++)
      write_ptr = M_cam[i].serialize(write_ptr, seq);
    uint32_t __M_laser_size = M_laser.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __M_laser_size);
    for (size_t i = 0; i < __M_laser_size; i++)
      write_ptr = M_laser[i].serialize(write_ptr, seq);
    uint32_t __M_chain_size = M_chain.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __M_chain_size);
    for (size_t i = 0; i < __M_chain_size; i++)
      write_ptr = M_chain[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_sample_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_sample_id_len);
    sample_id = std::string((const char *)read_ptr, __ros_sample_id_len);
    read_ptr += __ros_sample_id_len;
    unsigned __ros_target_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_target_id_len);
    target_id = std::string((const char *)read_ptr, __ros_target_id_len);
    read_ptr += __ros_target_id_len;
    unsigned __ros_chain_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_chain_id_len);
    chain_id = std::string((const char *)read_ptr, __ros_chain_id_len);
    read_ptr += __ros_chain_id_len;
    uint32_t __M_cam_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __M_cam_size);
    set_M_cam_size(__M_cam_size);
    for (size_t i = 0; i < __M_cam_size; i++)
      read_ptr = M_cam[i].deserialize(read_ptr);
    uint32_t __M_laser_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __M_laser_size);
    set_M_laser_size(__M_laser_size);
    for (size_t i = 0; i < __M_laser_size; i++)
      read_ptr = M_laser[i].deserialize(read_ptr);
    uint32_t __M_chain_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __M_chain_size);
    set_M_chain_size(__M_chain_size);
    for (size_t i = 0; i < __M_chain_size; i++)
      read_ptr = M_chain[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<RobotMeasurement> RobotMeasurementPtr;
typedef boost::shared_ptr<RobotMeasurement const> RobotMeasurementConstPtr;


}

#endif
