# autogenerated by genmsg_py from DenseLaserObjectFeatures.msg. Do not edit.
import roslib.message
import struct

import calibration_msgs.msg
import geometry_msgs.msg
import roslib.msg

class DenseLaserObjectFeatures(roslib.message.Message):
  _md5sum = "b642d46e47d54e00f98a3d98b02b5cc6"
  _type = "calibration_msgs/DenseLaserObjectFeatures"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Synchronized with sensor output
Header header

# Pixel locations of detected features
DenseLaserPoint[] dense_laser_points

# Defines geometry of detected features in some "object" coordinate frame
geometry_msgs/Point[] object_points

# False on detection failure or partial detection
uint8 success

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: calibration_msgs/DenseLaserPoint
# Stores the xy subpixel location of a point in a DenseLaserSnapshot
float64 scan  # Which scan line we detected the feature
float64 ray   # Which ray in the specified scan we detected the feature

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

"""
  __slots__ = ['header','dense_laser_points','object_points','success']
  _slot_types = ['Header','calibration_msgs/DenseLaserPoint[]','geometry_msgs/Point[]','uint8']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,dense_laser_points,object_points,success
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(DenseLaserObjectFeatures, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.dense_laser_points is None:
        self.dense_laser_points = []
      if self.object_points is None:
        self.object_points = []
      if self.success is None:
        self.success = 0
    else:
      self.header = roslib.msg._Header.Header()
      self.dense_laser_points = []
      self.object_points = []
      self.success = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.dense_laser_points
      length = len(self.dense_laser_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.dense_laser_points:
        buff.write(struct.pack('<2d', val1.scan, val1.ray))
      #serialize self.object_points
      length = len(self.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.object_points:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<B', self.success))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.dense_laser_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.dense_laser_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.DenseLaserPoint()
        start = end
        end += 16
        (val1.scan, val1.ray,) = struct.unpack('<2d',str[start:end])
        self.dense_laser_points.append(val1)
      #deserialize self.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.object_points.append(val1)
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.dense_laser_points
      length = len(self.dense_laser_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.dense_laser_points:
        buff.write(struct.pack('<2d', val1.scan, val1.ray))
      #serialize self.object_points
      length = len(self.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.object_points:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<B', self.success))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.dense_laser_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.dense_laser_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.DenseLaserPoint()
        start = end
        end += 16
        (val1.scan, val1.ray,) = struct.unpack('<2d',str[start:end])
        self.dense_laser_points.append(val1)
      #deserialize self.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.object_points.append(val1)
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

