# autogenerated by genmsg_py from JointStateCalibrationPattern.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import sensor_msgs.msg

class JointStateCalibrationPattern(roslib.message.Message):
  _md5sum = "2a9763ecd4115aab77fac06c99ae1fb7"
  _type = "calibration_msgs/JointStateCalibrationPattern"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header
geometry_msgs/Point32[]  object_points
sensor_msgs/JointState[] joint_points


================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

"""
  __slots__ = ['header','object_points','joint_points']
  _slot_types = ['Header','geometry_msgs/Point32[]','sensor_msgs/JointState[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,object_points,joint_points
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(JointStateCalibrationPattern, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.object_points is None:
        self.object_points = []
      if self.joint_points is None:
        self.joint_points = []
    else:
      self.header = roslib.msg._Header.Header()
      self.object_points = []
      self.joint_points = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.object_points
      length = len(self.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.joint_points
      length = len(self.joint_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_points:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        #serialize val1.name
        length = len(val1.name)
        buff.write(struct.pack('<I', length))
        for val2 in val1.name:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.position
        length = len(val1.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.position))
        #serialize val1.velocity
        length = len(val1.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.velocity))
        #serialize val1.effort
        length = len(val1.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.object_points.append(val1)
      #deserialize self.joint_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_points = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.JointState()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.name.append(val2)
        #deserialize val1.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.position = struct.unpack(pattern, str[start:end])
        #deserialize val1.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocity = struct.unpack(pattern, str[start:end])
        #deserialize val1.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = struct.unpack(pattern, str[start:end])
        self.joint_points.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.object_points
      length = len(self.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.joint_points
      length = len(self.joint_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_points:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        #serialize val1.name
        length = len(val1.name)
        buff.write(struct.pack('<I', length))
        for val2 in val1.name:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.position
        length = len(val1.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.position.tostring())
        #serialize val1.velocity
        length = len(val1.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.velocity.tostring())
        #serialize val1.effort
        length = len(val1.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.effort.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.object_points.append(val1)
      #deserialize self.joint_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_points = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.JointState()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.name.append(val2)
        #deserialize val1.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.joint_points.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

