# autogenerated by genmsg_py from LaserMeasurement.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import calibration_msgs.msg
import geometry_msgs.msg
import roslib.msg
import sensor_msgs.msg

class LaserMeasurement(roslib.message.Message):
  _md5sum = "03ce2d57df2a0cedc1a91dc4b40d7729"
  _type = "calibration_msgs/LaserMeasurement"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header
string laser_id
sensor_msgs/JointState[] joint_points

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
calibration_msgs/DenseLaserSnapshot snapshot
sensor_msgs/Image laser_image
calibration_msgs/CalibrationPattern image_features
calibration_msgs/JointStateCalibrationPattern joint_features

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: calibration_msgs/DenseLaserSnapshot
# Provides all the state & sensor information for
# a single sweep of laser attached to some mechanism.
# Most likely, this will be used with PR2's tilting laser mechanism
Header header

# Store the laser intrinsics. This is very similar to the
# intrinsics commonly stored in 
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]
float32 time_increment   # time between measurements [seconds]
float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

# Define the size of the binary data
uint32 readings_per_scan    # (Width)
uint32 num_scans            # (Height)

# 2D Arrays storing laser data.
# We can think of each type data as being a single channel image.
# Each row of the image has data from a single scan, and scans are
# concatenated to form the entire 'image'.
float32[] ranges            # (Image data)
float32[] intensities       # (Image data)

# Store the start time of each scan
time[] scan_start

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: calibration_msgs/CalibrationPattern
Header header
geometry_msgs/Point32[] object_points
ImagePoint[] image_points
uint8 success

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: calibration_msgs/ImagePoint
float32 x
float32 y

================================================================================
MSG: calibration_msgs/JointStateCalibrationPattern
Header header
geometry_msgs/Point32[]  object_points
sensor_msgs/JointState[] joint_points


"""
  __slots__ = ['header','laser_id','joint_points','verbose','snapshot','laser_image','image_features','joint_features']
  _slot_types = ['Header','string','sensor_msgs/JointState[]','bool','calibration_msgs/DenseLaserSnapshot','sensor_msgs/Image','calibration_msgs/CalibrationPattern','calibration_msgs/JointStateCalibrationPattern']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,laser_id,joint_points,verbose,snapshot,laser_image,image_features,joint_features
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(LaserMeasurement, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.laser_id is None:
        self.laser_id = ''
      if self.joint_points is None:
        self.joint_points = []
      if self.verbose is None:
        self.verbose = False
      if self.snapshot is None:
        self.snapshot = calibration_msgs.msg.DenseLaserSnapshot()
      if self.laser_image is None:
        self.laser_image = sensor_msgs.msg.Image()
      if self.image_features is None:
        self.image_features = calibration_msgs.msg.CalibrationPattern()
      if self.joint_features is None:
        self.joint_features = calibration_msgs.msg.JointStateCalibrationPattern()
    else:
      self.header = roslib.msg._Header.Header()
      self.laser_id = ''
      self.joint_points = []
      self.verbose = False
      self.snapshot = calibration_msgs.msg.DenseLaserSnapshot()
      self.laser_image = sensor_msgs.msg.Image()
      self.image_features = calibration_msgs.msg.CalibrationPattern()
      self.joint_features = calibration_msgs.msg.JointStateCalibrationPattern()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.laser_id)
      #serialize self.laser_id
      buff.write(struct.pack('<I%ss'%length, length, self.laser_id))
      #serialize self.joint_points
      length = len(self.joint_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_points:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        #serialize val1.name
        length = len(val1.name)
        buff.write(struct.pack('<I', length))
        for val2 in val1.name:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.position
        length = len(val1.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.position))
        #serialize val1.velocity
        length = len(val1.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.velocity))
        #serialize val1.effort
        length = len(val1.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.effort))
      buff.write(struct.pack('<B3I', self.verbose, self.snapshot.header.seq, self.snapshot.header.stamp.secs, self.snapshot.header.stamp.nsecs))
      length = len(self.snapshot.header.frame_id)
      #serialize self.snapshot.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.snapshot.header.frame_id))
      buff.write(struct.pack('<6f2I', self.snapshot.angle_min, self.snapshot.angle_max, self.snapshot.angle_increment, self.snapshot.time_increment, self.snapshot.range_min, self.snapshot.range_max, self.snapshot.readings_per_scan, self.snapshot.num_scans))
      #serialize self.snapshot.ranges
      length = len(self.snapshot.ranges)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.snapshot.ranges))
      #serialize self.snapshot.intensities
      length = len(self.snapshot.intensities)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.snapshot.intensities))
      #serialize self.snapshot.scan_start
      length = len(self.snapshot.scan_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.snapshot.scan_start:
        buff.write(struct.pack('<2I', val1.secs, val1.nsecs))
      buff.write(struct.pack('<3I', self.laser_image.header.seq, self.laser_image.header.stamp.secs, self.laser_image.header.stamp.nsecs))
      length = len(self.laser_image.header.frame_id)
      #serialize self.laser_image.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.laser_image.header.frame_id))
      buff.write(struct.pack('<2I', self.laser_image.height, self.laser_image.width))
      length = len(self.laser_image.encoding)
      #serialize self.laser_image.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.laser_image.encoding))
      buff.write(struct.pack('<BI', self.laser_image.is_bigendian, self.laser_image.step))
      length = len(self.laser_image.data)
      #serialize self.laser_image.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.laser_image.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.laser_image.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.laser_image.data))
      buff.write(struct.pack('<3I', self.image_features.header.seq, self.image_features.header.stamp.secs, self.image_features.header.stamp.nsecs))
      length = len(self.image_features.header.frame_id)
      #serialize self.image_features.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image_features.header.frame_id))
      #serialize self.image_features.object_points
      length = len(self.image_features.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.image_features.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.image_features.image_points
      length = len(self.image_features.image_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.image_features.image_points:
        buff.write(struct.pack('<2f', val1.x, val1.y))
      buff.write(struct.pack('<B3I', self.image_features.success, self.joint_features.header.seq, self.joint_features.header.stamp.secs, self.joint_features.header.stamp.nsecs))
      length = len(self.joint_features.header.frame_id)
      #serialize self.joint_features.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.joint_features.header.frame_id))
      #serialize self.joint_features.object_points
      length = len(self.joint_features.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_features.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.joint_features.joint_points
      length = len(self.joint_features.joint_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_features.joint_points:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        #serialize val1.name
        length = len(val1.name)
        buff.write(struct.pack('<I', length))
        for val2 in val1.name:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.position
        length = len(val1.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.position))
        #serialize val1.velocity
        length = len(val1.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.velocity))
        #serialize val1.effort
        length = len(val1.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.snapshot is None:
        self.snapshot = calibration_msgs.msg.DenseLaserSnapshot()
      if self.laser_image is None:
        self.laser_image = sensor_msgs.msg.Image()
      if self.image_features is None:
        self.image_features = calibration_msgs.msg.CalibrationPattern()
      if self.joint_features is None:
        self.joint_features = calibration_msgs.msg.JointStateCalibrationPattern()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.joint_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_points = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.JointState()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.name.append(val2)
        #deserialize val1.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.position = struct.unpack(pattern, str[start:end])
        #deserialize val1.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocity = struct.unpack(pattern, str[start:end])
        #deserialize val1.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = struct.unpack(pattern, str[start:end])
        self.joint_points.append(val1)
      start = end
      end += 13
      (self.verbose, self.snapshot.header.seq, self.snapshot.header.stamp.secs, self.snapshot.header.stamp.nsecs,) = struct.unpack('<B3I',str[start:end])
      self.verbose = bool(self.verbose)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.snapshot.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.snapshot.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.snapshot.angle_min, self.snapshot.angle_max, self.snapshot.angle_increment, self.snapshot.time_increment, self.snapshot.range_min, self.snapshot.range_max, self.snapshot.readings_per_scan, self.snapshot.num_scans,) = struct.unpack('<6f2I',str[start:end])
      #deserialize self.snapshot.ranges
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.snapshot.ranges = struct.unpack(pattern, str[start:end])
      #deserialize self.snapshot.intensities
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.snapshot.intensities = struct.unpack(pattern, str[start:end])
      #deserialize self.snapshot.scan_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.snapshot.scan_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Time()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2I',str[start:end])
        self.snapshot.scan_start.append(val1)
      start = end
      end += 12
      (self.laser_image.header.seq, self.laser_image.header.stamp.secs, self.laser_image.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_image.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_image.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.laser_image.height, self.laser_image.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_image.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_image.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.laser_image.is_bigendian, self.laser_image.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_image.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_image.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.image_features.header.seq, self.image_features.header.stamp.secs, self.image_features.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_features.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.image_features.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.image_features.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.image_features.object_points.append(val1)
      #deserialize self.image_features.image_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.image_features.image_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ImagePoint()
        start = end
        end += 8
        (val1.x, val1.y,) = struct.unpack('<2f',str[start:end])
        self.image_features.image_points.append(val1)
      start = end
      end += 13
      (self.image_features.success, self.joint_features.header.seq, self.joint_features.header.stamp.secs, self.joint_features.header.stamp.nsecs,) = struct.unpack('<B3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_features.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.joint_features.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_features.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.joint_features.object_points.append(val1)
      #deserialize self.joint_features.joint_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_features.joint_points = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.JointState()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.name.append(val2)
        #deserialize val1.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.position = struct.unpack(pattern, str[start:end])
        #deserialize val1.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocity = struct.unpack(pattern, str[start:end])
        #deserialize val1.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = struct.unpack(pattern, str[start:end])
        self.joint_features.joint_points.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.laser_id)
      #serialize self.laser_id
      buff.write(struct.pack('<I%ss'%length, length, self.laser_id))
      #serialize self.joint_points
      length = len(self.joint_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_points:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        #serialize val1.name
        length = len(val1.name)
        buff.write(struct.pack('<I', length))
        for val2 in val1.name:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.position
        length = len(val1.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.position.tostring())
        #serialize val1.velocity
        length = len(val1.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.velocity.tostring())
        #serialize val1.effort
        length = len(val1.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.effort.tostring())
      buff.write(struct.pack('<B3I', self.verbose, self.snapshot.header.seq, self.snapshot.header.stamp.secs, self.snapshot.header.stamp.nsecs))
      length = len(self.snapshot.header.frame_id)
      #serialize self.snapshot.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.snapshot.header.frame_id))
      buff.write(struct.pack('<6f2I', self.snapshot.angle_min, self.snapshot.angle_max, self.snapshot.angle_increment, self.snapshot.time_increment, self.snapshot.range_min, self.snapshot.range_max, self.snapshot.readings_per_scan, self.snapshot.num_scans))
      #serialize self.snapshot.ranges
      length = len(self.snapshot.ranges)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(self.snapshot.ranges.tostring())
      #serialize self.snapshot.intensities
      length = len(self.snapshot.intensities)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(self.snapshot.intensities.tostring())
      #serialize self.snapshot.scan_start
      length = len(self.snapshot.scan_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.snapshot.scan_start:
        buff.write(struct.pack('<2I', val1.secs, val1.nsecs))
      buff.write(struct.pack('<3I', self.laser_image.header.seq, self.laser_image.header.stamp.secs, self.laser_image.header.stamp.nsecs))
      length = len(self.laser_image.header.frame_id)
      #serialize self.laser_image.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.laser_image.header.frame_id))
      buff.write(struct.pack('<2I', self.laser_image.height, self.laser_image.width))
      length = len(self.laser_image.encoding)
      #serialize self.laser_image.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.laser_image.encoding))
      buff.write(struct.pack('<BI', self.laser_image.is_bigendian, self.laser_image.step))
      length = len(self.laser_image.data)
      #serialize self.laser_image.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.laser_image.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.laser_image.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.laser_image.data))
      buff.write(struct.pack('<3I', self.image_features.header.seq, self.image_features.header.stamp.secs, self.image_features.header.stamp.nsecs))
      length = len(self.image_features.header.frame_id)
      #serialize self.image_features.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image_features.header.frame_id))
      #serialize self.image_features.object_points
      length = len(self.image_features.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.image_features.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.image_features.image_points
      length = len(self.image_features.image_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.image_features.image_points:
        buff.write(struct.pack('<2f', val1.x, val1.y))
      buff.write(struct.pack('<B3I', self.image_features.success, self.joint_features.header.seq, self.joint_features.header.stamp.secs, self.joint_features.header.stamp.nsecs))
      length = len(self.joint_features.header.frame_id)
      #serialize self.joint_features.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.joint_features.header.frame_id))
      #serialize self.joint_features.object_points
      length = len(self.joint_features.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_features.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.joint_features.joint_points
      length = len(self.joint_features.joint_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_features.joint_points:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        #serialize val1.name
        length = len(val1.name)
        buff.write(struct.pack('<I', length))
        for val2 in val1.name:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.position
        length = len(val1.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.position.tostring())
        #serialize val1.velocity
        length = len(val1.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.velocity.tostring())
        #serialize val1.effort
        length = len(val1.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.effort.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.snapshot is None:
        self.snapshot = calibration_msgs.msg.DenseLaserSnapshot()
      if self.laser_image is None:
        self.laser_image = sensor_msgs.msg.Image()
      if self.image_features is None:
        self.image_features = calibration_msgs.msg.CalibrationPattern()
      if self.joint_features is None:
        self.joint_features = calibration_msgs.msg.JointStateCalibrationPattern()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.joint_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_points = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.JointState()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.name.append(val2)
        #deserialize val1.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.joint_points.append(val1)
      start = end
      end += 13
      (self.verbose, self.snapshot.header.seq, self.snapshot.header.stamp.secs, self.snapshot.header.stamp.nsecs,) = struct.unpack('<B3I',str[start:end])
      self.verbose = bool(self.verbose)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.snapshot.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.snapshot.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.snapshot.angle_min, self.snapshot.angle_max, self.snapshot.angle_increment, self.snapshot.time_increment, self.snapshot.range_min, self.snapshot.range_max, self.snapshot.readings_per_scan, self.snapshot.num_scans,) = struct.unpack('<6f2I',str[start:end])
      #deserialize self.snapshot.ranges
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.snapshot.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      #deserialize self.snapshot.intensities
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.snapshot.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      #deserialize self.snapshot.scan_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.snapshot.scan_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Time()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2I',str[start:end])
        self.snapshot.scan_start.append(val1)
      start = end
      end += 12
      (self.laser_image.header.seq, self.laser_image.header.stamp.secs, self.laser_image.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_image.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_image.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.laser_image.height, self.laser_image.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_image.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_image.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.laser_image.is_bigendian, self.laser_image.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.laser_image.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.laser_image.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.image_features.header.seq, self.image_features.header.stamp.secs, self.image_features.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_features.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.image_features.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.image_features.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.image_features.object_points.append(val1)
      #deserialize self.image_features.image_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.image_features.image_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ImagePoint()
        start = end
        end += 8
        (val1.x, val1.y,) = struct.unpack('<2f',str[start:end])
        self.image_features.image_points.append(val1)
      start = end
      end += 13
      (self.image_features.success, self.joint_features.header.seq, self.joint_features.header.stamp.secs, self.joint_features.header.stamp.nsecs,) = struct.unpack('<B3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_features.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.joint_features.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_features.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.joint_features.object_points.append(val1)
      #deserialize self.joint_features.joint_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_features.joint_points = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.JointState()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.name.append(val2)
        #deserialize val1.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.joint_features.joint_points.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

