# autogenerated by genmsg_py from RobotMeasurement.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import calibration_msgs.msg
import geometry_msgs.msg
import roslib.msg
import sensor_msgs.msg

class RobotMeasurement(roslib.message.Message):
  _md5sum = "a678b901730e88bab47546163d96aa5b"
  _type = "calibration_msgs/RobotMeasurement"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string sample_id    # Tag to figure out which yaml file this was generated from

string target_id    # Defines the target that we were sensing.
string chain_id     # Defines where this target was attached

CameraMeasurement[] M_cam
LaserMeasurement[]  M_laser
ChainMeasurement[]  M_chain

================================================================================
MSG: calibration_msgs/CameraMeasurement
Header header
string camera_id
ImagePoint[] image_points
sensor_msgs/CameraInfo cam_info

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
sensor_msgs/Image image
sensor_msgs/Image image_rect
calibration_msgs/CalibrationPattern features

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: calibration_msgs/ImagePoint
float32 x
float32 y

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace and accompanied by up to 5 image topics named:
# 
# image_raw, image, image_color, image_rect, and image_rect_color
#
# The meaning of the camera parameters are described in detail at
# http://pr.willowgarage.com/wiki/Camera_Calibration.

##########################
# Image acquisition info #
##########################

# Time of image acquisition, camera coordinate frame ID
Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of camera
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image

# Camera resolution in pixels
uint32 height
uint32 width

# Region of interest (subwindow of full camera resolution), if applicable
RegionOfInterest roi

##########################################
# Internal parameters                    #
# Used for warping to:                   #
#  1. An undistorted image (just D and K)#
#  2. A rectified image (D, K, R)        #
# Users should not normally need these   #
##########################################

# Distortion parameters: k1, k2, t1, t2, k3
# These model radial and tangential distortion of the camera.
float64[5]  D # 5x1 vector

# Intrinsic camera matrix for the raw (distorted) images
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]

float64[9]  K # 3x3 row-major matrix


# Rectification matrix (stereo cameras only)
# A homography which takes an image to the ideal stereo image plane
# so that epipolar lines in both stereo images are parallel.
float64[9]  R # 3x3 row-major matrix

######################################
# Projection/camera matrix           #
# This is a 3x4 projection matrix    #
#   for going from 3D to 2D coords   #
######################################

# Projection/camera matrix
# By convention, this matrix specifies the intrinsic (camera)
#   matrix of the processed (rectified) image.
# Upper 3x3 portion is the normal camera intrinsic matrix for
#   the rectified image
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#              [fx  0 cx]
# P[1:3,1:3] = [ 0 fy cy]
#              [ 0  0  1]
# For the right camera of a stereo pair, P[4,1] is the position
#  of the right camera center in the left camera's frame, times
#  the focal length fx.
# 
# Given a 3D point q=[XYZ]^T in the left camera frame, the projection
#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.
#  This holds for both left and right images of a stereo pair.  
#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.

float64[12] P # 3x4 row-major matrix

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image
#
# When used to specify the ROI setting of the camera when the image was taken,
# the height and width fields should either match the height and width
# fields for the associated image or be zeroes to indicate that the full image
# was captured

uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)
uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)
uint32 height    #Height of ROI
uint32 width     #Width of ROI

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: calibration_msgs/CalibrationPattern
Header header
geometry_msgs/Point32[] object_points
ImagePoint[] image_points
uint8 success

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: calibration_msgs/LaserMeasurement
Header header
string laser_id
sensor_msgs/JointState[] joint_points

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
calibration_msgs/DenseLaserSnapshot snapshot
sensor_msgs/Image laser_image
calibration_msgs/CalibrationPattern image_features
calibration_msgs/JointStateCalibrationPattern joint_features

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: calibration_msgs/DenseLaserSnapshot
# Provides all the state & sensor information for
# a single sweep of laser attached to some mechanism.
# Most likely, this will be used with PR2's tilting laser mechanism
Header header

# Store the laser intrinsics. This is very similar to the
# intrinsics commonly stored in 
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]
float32 time_increment   # time between measurements [seconds]
float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

# Define the size of the binary data
uint32 readings_per_scan    # (Width)
uint32 num_scans            # (Height)

# 2D Arrays storing laser data.
# We can think of each type data as being a single channel image.
# Each row of the image has data from a single scan, and scans are
# concatenated to form the entire 'image'.
float32[] ranges            # (Image data)
float32[] intensities       # (Image data)

# Store the start time of each scan
time[] scan_start

================================================================================
MSG: calibration_msgs/JointStateCalibrationPattern
Header header
geometry_msgs/Point32[]  object_points
sensor_msgs/JointState[] joint_points


================================================================================
MSG: calibration_msgs/ChainMeasurement
Header header
string chain_id
sensor_msgs/JointState chain_state

"""
  __slots__ = ['sample_id','target_id','chain_id','M_cam','M_laser','M_chain']
  _slot_types = ['string','string','string','calibration_msgs/CameraMeasurement[]','calibration_msgs/LaserMeasurement[]','calibration_msgs/ChainMeasurement[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   sample_id,target_id,chain_id,M_cam,M_laser,M_chain
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(RobotMeasurement, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.sample_id is None:
        self.sample_id = ''
      if self.target_id is None:
        self.target_id = ''
      if self.chain_id is None:
        self.chain_id = ''
      if self.M_cam is None:
        self.M_cam = []
      if self.M_laser is None:
        self.M_laser = []
      if self.M_chain is None:
        self.M_chain = []
    else:
      self.sample_id = ''
      self.target_id = ''
      self.chain_id = ''
      self.M_cam = []
      self.M_laser = []
      self.M_chain = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.sample_id)
      #serialize self.sample_id
      buff.write(struct.pack('<I%ss'%length, length, self.sample_id))
      length = len(self.target_id)
      #serialize self.target_id
      buff.write(struct.pack('<I%ss'%length, length, self.target_id))
      length = len(self.chain_id)
      #serialize self.chain_id
      buff.write(struct.pack('<I%ss'%length, length, self.chain_id))
      #serialize self.M_cam
      length = len(self.M_cam)
      buff.write(struct.pack('<I', length))
      for val1 in self.M_cam:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.camera_id)
        #serialize val1.camera_id
        buff.write(struct.pack('<I%ss'%length, length, val1.camera_id))
        #serialize val1.image_points
        length = len(val1.image_points)
        buff.write(struct.pack('<I', length))
        for val2 in val1.image_points:
          buff.write(struct.pack('<2f', val2.x, val2.y))
        buff.write(struct.pack('<I', val1.cam_info.header.seq))
        buff.write(struct.pack('<2I', val1.cam_info.header.stamp.secs, val1.cam_info.header.stamp.nsecs))
        length = len(val1.cam_info.header.frame_id)
        #serialize val1.cam_info.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.cam_info.header.frame_id))
        buff.write(struct.pack('<2I', val1.cam_info.height, val1.cam_info.width))
        buff.write(struct.pack('<4I', val1.cam_info.roi.x_offset, val1.cam_info.roi.y_offset, val1.cam_info.roi.height, val1.cam_info.roi.width))
        #serialize val1.cam_info.D
        buff.write(struct.pack('<5d', *val1.cam_info.D))
        #serialize val1.cam_info.K
        buff.write(struct.pack('<9d', *val1.cam_info.K))
        #serialize val1.cam_info.R
        buff.write(struct.pack('<9d', *val1.cam_info.R))
        #serialize val1.cam_info.P
        buff.write(struct.pack('<12d', *val1.cam_info.P))
        buff.write(struct.pack('<B', val1.verbose))
        buff.write(struct.pack('<I', val1.image.header.seq))
        buff.write(struct.pack('<2I', val1.image.header.stamp.secs, val1.image.header.stamp.nsecs))
        length = len(val1.image.header.frame_id)
        #serialize val1.image.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.image.header.frame_id))
        buff.write(struct.pack('<2I', val1.image.height, val1.image.width))
        length = len(val1.image.encoding)
        #serialize val1.image.encoding
        buff.write(struct.pack('<I%ss'%length, length, val1.image.encoding))
        buff.write(struct.pack('<BI', val1.image.is_bigendian, val1.image.step))
        length = len(val1.image.data)
        #serialize val1.image.data
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(val1.image.data) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *val1.image.data))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1.image.data))
        buff.write(struct.pack('<I', val1.image_rect.header.seq))
        buff.write(struct.pack('<2I', val1.image_rect.header.stamp.secs, val1.image_rect.header.stamp.nsecs))
        length = len(val1.image_rect.header.frame_id)
        #serialize val1.image_rect.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.image_rect.header.frame_id))
        buff.write(struct.pack('<2I', val1.image_rect.height, val1.image_rect.width))
        length = len(val1.image_rect.encoding)
        #serialize val1.image_rect.encoding
        buff.write(struct.pack('<I%ss'%length, length, val1.image_rect.encoding))
        buff.write(struct.pack('<BI', val1.image_rect.is_bigendian, val1.image_rect.step))
        length = len(val1.image_rect.data)
        #serialize val1.image_rect.data
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(val1.image_rect.data) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *val1.image_rect.data))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1.image_rect.data))
        buff.write(struct.pack('<I', val1.features.header.seq))
        buff.write(struct.pack('<2I', val1.features.header.stamp.secs, val1.features.header.stamp.nsecs))
        length = len(val1.features.header.frame_id)
        #serialize val1.features.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.features.header.frame_id))
        #serialize val1.features.object_points
        length = len(val1.features.object_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.features.object_points:
          buff.write(struct.pack('<3f', val3.x, val3.y, val3.z))
        #serialize val1.features.image_points
        length = len(val1.features.image_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.features.image_points:
          buff.write(struct.pack('<2f', val3.x, val3.y))
        buff.write(struct.pack('<B', val1.features.success))
      #serialize self.M_laser
      length = len(self.M_laser)
      buff.write(struct.pack('<I', length))
      for val1 in self.M_laser:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.laser_id)
        #serialize val1.laser_id
        buff.write(struct.pack('<I%ss'%length, length, val1.laser_id))
        #serialize val1.joint_points
        length = len(val1.joint_points)
        buff.write(struct.pack('<I', length))
        for val2 in val1.joint_points:
          buff.write(struct.pack('<I', val2.header.seq))
          buff.write(struct.pack('<2I', val2.header.stamp.secs, val2.header.stamp.nsecs))
          length = len(val2.header.frame_id)
          #serialize val2.header.frame_id
          buff.write(struct.pack('<I%ss'%length, length, val2.header.frame_id))
          #serialize val2.name
          length = len(val2.name)
          buff.write(struct.pack('<I', length))
          for val3 in val2.name:
            length = len(val3)
            #serialize val3
            buff.write(struct.pack('<I%ss'%length, length, val3))
          #serialize val2.position
          length = len(val2.position)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val2.position))
          #serialize val2.velocity
          length = len(val2.velocity)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val2.velocity))
          #serialize val2.effort
          length = len(val2.effort)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val2.effort))
        buff.write(struct.pack('<B', val1.verbose))
        buff.write(struct.pack('<I', val1.snapshot.header.seq))
        buff.write(struct.pack('<2I', val1.snapshot.header.stamp.secs, val1.snapshot.header.stamp.nsecs))
        length = len(val1.snapshot.header.frame_id)
        #serialize val1.snapshot.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.snapshot.header.frame_id))
        buff.write(struct.pack('<6f2I', val1.snapshot.angle_min, val1.snapshot.angle_max, val1.snapshot.angle_increment, val1.snapshot.time_increment, val1.snapshot.range_min, val1.snapshot.range_max, val1.snapshot.readings_per_scan, val1.snapshot.num_scans))
        #serialize val1.snapshot.ranges
        length = len(val1.snapshot.ranges)
        buff.write(struct.pack('<I', length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.snapshot.ranges))
        #serialize val1.snapshot.intensities
        length = len(val1.snapshot.intensities)
        buff.write(struct.pack('<I', length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.snapshot.intensities))
        #serialize val1.snapshot.scan_start
        length = len(val1.snapshot.scan_start)
        buff.write(struct.pack('<I', length))
        for val3 in val1.snapshot.scan_start:
          buff.write(struct.pack('<2I', val3.secs, val3.nsecs))
        buff.write(struct.pack('<I', val1.laser_image.header.seq))
        buff.write(struct.pack('<2I', val1.laser_image.header.stamp.secs, val1.laser_image.header.stamp.nsecs))
        length = len(val1.laser_image.header.frame_id)
        #serialize val1.laser_image.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.laser_image.header.frame_id))
        buff.write(struct.pack('<2I', val1.laser_image.height, val1.laser_image.width))
        length = len(val1.laser_image.encoding)
        #serialize val1.laser_image.encoding
        buff.write(struct.pack('<I%ss'%length, length, val1.laser_image.encoding))
        buff.write(struct.pack('<BI', val1.laser_image.is_bigendian, val1.laser_image.step))
        length = len(val1.laser_image.data)
        #serialize val1.laser_image.data
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(val1.laser_image.data) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *val1.laser_image.data))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1.laser_image.data))
        buff.write(struct.pack('<I', val1.image_features.header.seq))
        buff.write(struct.pack('<2I', val1.image_features.header.stamp.secs, val1.image_features.header.stamp.nsecs))
        length = len(val1.image_features.header.frame_id)
        #serialize val1.image_features.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.image_features.header.frame_id))
        #serialize val1.image_features.object_points
        length = len(val1.image_features.object_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.image_features.object_points:
          buff.write(struct.pack('<3f', val3.x, val3.y, val3.z))
        #serialize val1.image_features.image_points
        length = len(val1.image_features.image_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.image_features.image_points:
          buff.write(struct.pack('<2f', val3.x, val3.y))
        buff.write(struct.pack('<B', val1.image_features.success))
        buff.write(struct.pack('<I', val1.joint_features.header.seq))
        buff.write(struct.pack('<2I', val1.joint_features.header.stamp.secs, val1.joint_features.header.stamp.nsecs))
        length = len(val1.joint_features.header.frame_id)
        #serialize val1.joint_features.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_features.header.frame_id))
        #serialize val1.joint_features.object_points
        length = len(val1.joint_features.object_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.joint_features.object_points:
          buff.write(struct.pack('<3f', val3.x, val3.y, val3.z))
        #serialize val1.joint_features.joint_points
        length = len(val1.joint_features.joint_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.joint_features.joint_points:
          buff.write(struct.pack('<I', val3.header.seq))
          buff.write(struct.pack('<2I', val3.header.stamp.secs, val3.header.stamp.nsecs))
          length = len(val3.header.frame_id)
          #serialize val3.header.frame_id
          buff.write(struct.pack('<I%ss'%length, length, val3.header.frame_id))
          #serialize val3.name
          length = len(val3.name)
          buff.write(struct.pack('<I', length))
          for val4 in val3.name:
            length = len(val4)
            #serialize val4
            buff.write(struct.pack('<I%ss'%length, length, val4))
          #serialize val3.position
          length = len(val3.position)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.position))
          #serialize val3.velocity
          length = len(val3.velocity)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.velocity))
          #serialize val3.effort
          length = len(val3.effort)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.effort))
      #serialize self.M_chain
      length = len(self.M_chain)
      buff.write(struct.pack('<I', length))
      for val1 in self.M_chain:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.chain_id)
        #serialize val1.chain_id
        buff.write(struct.pack('<I%ss'%length, length, val1.chain_id))
        buff.write(struct.pack('<I', val1.chain_state.header.seq))
        buff.write(struct.pack('<2I', val1.chain_state.header.stamp.secs, val1.chain_state.header.stamp.nsecs))
        length = len(val1.chain_state.header.frame_id)
        #serialize val1.chain_state.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.chain_state.header.frame_id))
        #serialize val1.chain_state.name
        length = len(val1.chain_state.name)
        buff.write(struct.pack('<I', length))
        for val3 in val1.chain_state.name:
          length = len(val3)
          #serialize val3
          buff.write(struct.pack('<I%ss'%length, length, val3))
        #serialize val1.chain_state.position
        length = len(val1.chain_state.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.chain_state.position))
        #serialize val1.chain_state.velocity
        length = len(val1.chain_state.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.chain_state.velocity))
        #serialize val1.chain_state.effort
        length = len(val1.chain_state.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.chain_state.effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.sample_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.sample_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.target_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.target_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.chain_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.chain_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.M_cam
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.M_cam = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.CameraMeasurement()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.camera_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.camera_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.image_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.image_points = []
        for i in xrange(0, length):
          val2 = calibration_msgs.msg.ImagePoint()
          start = end
          end += 8
          (val2.x, val2.y,) = struct.unpack('<2f',str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (val1.cam_info.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.cam_info.header.stamp.secs, val1.cam_info.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.cam_info.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.cam_info.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.cam_info.height, val1.cam_info.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 16
        (val1.cam_info.roi.x_offset, val1.cam_info.roi.y_offset, val1.cam_info.roi.height, val1.cam_info.roi.width,) = struct.unpack('<4I',str[start:end])
        #deserialize val1.cam_info.D
        start = end
        end += 40
        val1.cam_info.D = struct.unpack('<5d',str[start:end])
        #deserialize val1.cam_info.K
        start = end
        end += 72
        val1.cam_info.K = struct.unpack('<9d',str[start:end])
        #deserialize val1.cam_info.R
        start = end
        end += 72
        val1.cam_info.R = struct.unpack('<9d',str[start:end])
        #deserialize val1.cam_info.P
        start = end
        end += 96
        val1.cam_info.P = struct.unpack('<12d',str[start:end])
        start = end
        end += 1
        (val1.verbose,) = struct.unpack('<B',str[start:end])
        val1.verbose = bool(val1.verbose)
        start = end
        end += 4
        (val1.image.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.image.header.stamp.secs, val1.image.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.image.height, val1.image.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image.encoding
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image.encoding,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 5
        (val1.image.is_bigendian, val1.image.step,) = struct.unpack('<BI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image.data
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image.data,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.image_rect.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.image_rect.header.stamp.secs, val1.image_rect.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_rect.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_rect.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.image_rect.height, val1.image_rect.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_rect.encoding
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_rect.encoding,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 5
        (val1.image_rect.is_bigendian, val1.image_rect.step,) = struct.unpack('<BI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_rect.data
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_rect.data,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.features.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.features.header.stamp.secs, val1.features.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.features.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.features.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.features.object_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.features.object_points = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point32()
          start = end
          end += 12
          (val3.x, val3.y, val3.z,) = struct.unpack('<3f',str[start:end])
          val1.features.object_points.append(val3)
        #deserialize val1.features.image_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.features.image_points = []
        for i in xrange(0, length):
          val3 = calibration_msgs.msg.ImagePoint()
          start = end
          end += 8
          (val3.x, val3.y,) = struct.unpack('<2f',str[start:end])
          val1.features.image_points.append(val3)
        start = end
        end += 1
        (val1.features.success,) = struct.unpack('<B',str[start:end])
        self.M_cam.append(val1)
      #deserialize self.M_laser
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.M_laser = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.LaserMeasurement()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_points = []
        for i in xrange(0, length):
          val2 = sensor_msgs.msg.JointState()
          start = end
          end += 4
          (val2.header.seq,) = struct.unpack('<I',str[start:end])
          start = end
          end += 8
          (val2.header.stamp.secs, val2.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2.header.frame_id
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2.header.frame_id,) = struct.unpack(pattern, str[start:end])
          #deserialize val2.name
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          val2.name = []
          for i in xrange(0, length):
            start = end
            end += 4
            (length,) = struct.unpack('<I',str[start:end])
            #deserialize val3
            pattern = '<%ss'%length
            start = end
            end += struct.calcsize(pattern)
            (val3,) = struct.unpack(pattern, str[start:end])
            val2.name.append(val3)
          #deserialize val2.position
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.position = struct.unpack(pattern, str[start:end])
          #deserialize val2.velocity
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.velocity = struct.unpack(pattern, str[start:end])
          #deserialize val2.effort
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.effort = struct.unpack(pattern, str[start:end])
          val1.joint_points.append(val2)
        start = end
        end += 1
        (val1.verbose,) = struct.unpack('<B',str[start:end])
        val1.verbose = bool(val1.verbose)
        start = end
        end += 4
        (val1.snapshot.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.snapshot.header.stamp.secs, val1.snapshot.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.snapshot.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.snapshot.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.snapshot.angle_min, val1.snapshot.angle_max, val1.snapshot.angle_increment, val1.snapshot.time_increment, val1.snapshot.range_min, val1.snapshot.range_max, val1.snapshot.readings_per_scan, val1.snapshot.num_scans,) = struct.unpack('<6f2I',str[start:end])
        #deserialize val1.snapshot.ranges
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.snapshot.ranges = struct.unpack(pattern, str[start:end])
        #deserialize val1.snapshot.intensities
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.snapshot.intensities = struct.unpack(pattern, str[start:end])
        #deserialize val1.snapshot.scan_start
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.snapshot.scan_start = []
        for i in xrange(0, length):
          val3 = roslib.rostime.Time()
          start = end
          end += 8
          (val3.secs, val3.nsecs,) = struct.unpack('<2I',str[start:end])
          val1.snapshot.scan_start.append(val3)
        start = end
        end += 4
        (val1.laser_image.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.laser_image.header.stamp.secs, val1.laser_image.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_image.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_image.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.laser_image.height, val1.laser_image.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_image.encoding
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_image.encoding,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 5
        (val1.laser_image.is_bigendian, val1.laser_image.step,) = struct.unpack('<BI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_image.data
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_image.data,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.image_features.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.image_features.header.stamp.secs, val1.image_features.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_features.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.image_features.object_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.image_features.object_points = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point32()
          start = end
          end += 12
          (val3.x, val3.y, val3.z,) = struct.unpack('<3f',str[start:end])
          val1.image_features.object_points.append(val3)
        #deserialize val1.image_features.image_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.image_features.image_points = []
        for i in xrange(0, length):
          val3 = calibration_msgs.msg.ImagePoint()
          start = end
          end += 8
          (val3.x, val3.y,) = struct.unpack('<2f',str[start:end])
          val1.image_features.image_points.append(val3)
        start = end
        end += 1
        (val1.image_features.success,) = struct.unpack('<B',str[start:end])
        start = end
        end += 4
        (val1.joint_features.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.joint_features.header.stamp.secs, val1.joint_features.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_features.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_features.object_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_features.object_points = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point32()
          start = end
          end += 12
          (val3.x, val3.y, val3.z,) = struct.unpack('<3f',str[start:end])
          val1.joint_features.object_points.append(val3)
        #deserialize val1.joint_features.joint_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_features.joint_points = []
        for i in xrange(0, length):
          val3 = sensor_msgs.msg.JointState()
          start = end
          end += 4
          (val3.header.seq,) = struct.unpack('<I',str[start:end])
          start = end
          end += 8
          (val3.header.stamp.secs, val3.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val3.header.frame_id
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val3.header.frame_id,) = struct.unpack(pattern, str[start:end])
          #deserialize val3.name
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          val3.name = []
          for i in xrange(0, length):
            start = end
            end += 4
            (length,) = struct.unpack('<I',str[start:end])
            #deserialize val4
            pattern = '<%ss'%length
            start = end
            end += struct.calcsize(pattern)
            (val4,) = struct.unpack(pattern, str[start:end])
            val3.name.append(val4)
          #deserialize val3.position
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.position = struct.unpack(pattern, str[start:end])
          #deserialize val3.velocity
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.velocity = struct.unpack(pattern, str[start:end])
          #deserialize val3.effort
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.effort = struct.unpack(pattern, str[start:end])
          val1.joint_features.joint_points.append(val3)
        self.M_laser.append(val1)
      #deserialize self.M_chain
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.M_chain = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ChainMeasurement()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.chain_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.chain_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.chain_state.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.chain_state.header.stamp.secs, val1.chain_state.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.chain_state.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.chain_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.chain_state.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.chain_state.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val3
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val3,) = struct.unpack(pattern, str[start:end])
          val1.chain_state.name.append(val3)
        #deserialize val1.chain_state.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.chain_state.position = struct.unpack(pattern, str[start:end])
        #deserialize val1.chain_state.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.chain_state.velocity = struct.unpack(pattern, str[start:end])
        #deserialize val1.chain_state.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.chain_state.effort = struct.unpack(pattern, str[start:end])
        self.M_chain.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.sample_id)
      #serialize self.sample_id
      buff.write(struct.pack('<I%ss'%length, length, self.sample_id))
      length = len(self.target_id)
      #serialize self.target_id
      buff.write(struct.pack('<I%ss'%length, length, self.target_id))
      length = len(self.chain_id)
      #serialize self.chain_id
      buff.write(struct.pack('<I%ss'%length, length, self.chain_id))
      #serialize self.M_cam
      length = len(self.M_cam)
      buff.write(struct.pack('<I', length))
      for val1 in self.M_cam:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.camera_id)
        #serialize val1.camera_id
        buff.write(struct.pack('<I%ss'%length, length, val1.camera_id))
        #serialize val1.image_points
        length = len(val1.image_points)
        buff.write(struct.pack('<I', length))
        for val2 in val1.image_points:
          buff.write(struct.pack('<2f', val2.x, val2.y))
        buff.write(struct.pack('<I', val1.cam_info.header.seq))
        buff.write(struct.pack('<2I', val1.cam_info.header.stamp.secs, val1.cam_info.header.stamp.nsecs))
        length = len(val1.cam_info.header.frame_id)
        #serialize val1.cam_info.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.cam_info.header.frame_id))
        buff.write(struct.pack('<2I', val1.cam_info.height, val1.cam_info.width))
        buff.write(struct.pack('<4I', val1.cam_info.roi.x_offset, val1.cam_info.roi.y_offset, val1.cam_info.roi.height, val1.cam_info.roi.width))
        #serialize val1.cam_info.D
        buff.write(val1.cam_info.D.tostring())
        #serialize val1.cam_info.K
        buff.write(val1.cam_info.K.tostring())
        #serialize val1.cam_info.R
        buff.write(val1.cam_info.R.tostring())
        #serialize val1.cam_info.P
        buff.write(val1.cam_info.P.tostring())
        buff.write(struct.pack('<B', val1.verbose))
        buff.write(struct.pack('<I', val1.image.header.seq))
        buff.write(struct.pack('<2I', val1.image.header.stamp.secs, val1.image.header.stamp.nsecs))
        length = len(val1.image.header.frame_id)
        #serialize val1.image.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.image.header.frame_id))
        buff.write(struct.pack('<2I', val1.image.height, val1.image.width))
        length = len(val1.image.encoding)
        #serialize val1.image.encoding
        buff.write(struct.pack('<I%ss'%length, length, val1.image.encoding))
        buff.write(struct.pack('<BI', val1.image.is_bigendian, val1.image.step))
        length = len(val1.image.data)
        #serialize val1.image.data
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(val1.image.data) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *val1.image.data))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1.image.data))
        buff.write(struct.pack('<I', val1.image_rect.header.seq))
        buff.write(struct.pack('<2I', val1.image_rect.header.stamp.secs, val1.image_rect.header.stamp.nsecs))
        length = len(val1.image_rect.header.frame_id)
        #serialize val1.image_rect.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.image_rect.header.frame_id))
        buff.write(struct.pack('<2I', val1.image_rect.height, val1.image_rect.width))
        length = len(val1.image_rect.encoding)
        #serialize val1.image_rect.encoding
        buff.write(struct.pack('<I%ss'%length, length, val1.image_rect.encoding))
        buff.write(struct.pack('<BI', val1.image_rect.is_bigendian, val1.image_rect.step))
        length = len(val1.image_rect.data)
        #serialize val1.image_rect.data
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(val1.image_rect.data) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *val1.image_rect.data))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1.image_rect.data))
        buff.write(struct.pack('<I', val1.features.header.seq))
        buff.write(struct.pack('<2I', val1.features.header.stamp.secs, val1.features.header.stamp.nsecs))
        length = len(val1.features.header.frame_id)
        #serialize val1.features.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.features.header.frame_id))
        #serialize val1.features.object_points
        length = len(val1.features.object_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.features.object_points:
          buff.write(struct.pack('<3f', val3.x, val3.y, val3.z))
        #serialize val1.features.image_points
        length = len(val1.features.image_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.features.image_points:
          buff.write(struct.pack('<2f', val3.x, val3.y))
        buff.write(struct.pack('<B', val1.features.success))
      #serialize self.M_laser
      length = len(self.M_laser)
      buff.write(struct.pack('<I', length))
      for val1 in self.M_laser:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.laser_id)
        #serialize val1.laser_id
        buff.write(struct.pack('<I%ss'%length, length, val1.laser_id))
        #serialize val1.joint_points
        length = len(val1.joint_points)
        buff.write(struct.pack('<I', length))
        for val2 in val1.joint_points:
          buff.write(struct.pack('<I', val2.header.seq))
          buff.write(struct.pack('<2I', val2.header.stamp.secs, val2.header.stamp.nsecs))
          length = len(val2.header.frame_id)
          #serialize val2.header.frame_id
          buff.write(struct.pack('<I%ss'%length, length, val2.header.frame_id))
          #serialize val2.name
          length = len(val2.name)
          buff.write(struct.pack('<I', length))
          for val3 in val2.name:
            length = len(val3)
            #serialize val3
            buff.write(struct.pack('<I%ss'%length, length, val3))
          #serialize val2.position
          length = len(val2.position)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(val2.position.tostring())
          #serialize val2.velocity
          length = len(val2.velocity)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(val2.velocity.tostring())
          #serialize val2.effort
          length = len(val2.effort)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(val2.effort.tostring())
        buff.write(struct.pack('<B', val1.verbose))
        buff.write(struct.pack('<I', val1.snapshot.header.seq))
        buff.write(struct.pack('<2I', val1.snapshot.header.stamp.secs, val1.snapshot.header.stamp.nsecs))
        length = len(val1.snapshot.header.frame_id)
        #serialize val1.snapshot.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.snapshot.header.frame_id))
        buff.write(struct.pack('<6f2I', val1.snapshot.angle_min, val1.snapshot.angle_max, val1.snapshot.angle_increment, val1.snapshot.time_increment, val1.snapshot.range_min, val1.snapshot.range_max, val1.snapshot.readings_per_scan, val1.snapshot.num_scans))
        #serialize val1.snapshot.ranges
        length = len(val1.snapshot.ranges)
        buff.write(struct.pack('<I', length))
        pattern = '<%sf'%length
        buff.write(val1.snapshot.ranges.tostring())
        #serialize val1.snapshot.intensities
        length = len(val1.snapshot.intensities)
        buff.write(struct.pack('<I', length))
        pattern = '<%sf'%length
        buff.write(val1.snapshot.intensities.tostring())
        #serialize val1.snapshot.scan_start
        length = len(val1.snapshot.scan_start)
        buff.write(struct.pack('<I', length))
        for val3 in val1.snapshot.scan_start:
          buff.write(struct.pack('<2I', val3.secs, val3.nsecs))
        buff.write(struct.pack('<I', val1.laser_image.header.seq))
        buff.write(struct.pack('<2I', val1.laser_image.header.stamp.secs, val1.laser_image.header.stamp.nsecs))
        length = len(val1.laser_image.header.frame_id)
        #serialize val1.laser_image.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.laser_image.header.frame_id))
        buff.write(struct.pack('<2I', val1.laser_image.height, val1.laser_image.width))
        length = len(val1.laser_image.encoding)
        #serialize val1.laser_image.encoding
        buff.write(struct.pack('<I%ss'%length, length, val1.laser_image.encoding))
        buff.write(struct.pack('<BI', val1.laser_image.is_bigendian, val1.laser_image.step))
        length = len(val1.laser_image.data)
        #serialize val1.laser_image.data
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(val1.laser_image.data) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *val1.laser_image.data))
        else:
          buff.write(struct.pack('<I%ss'%length, length, val1.laser_image.data))
        buff.write(struct.pack('<I', val1.image_features.header.seq))
        buff.write(struct.pack('<2I', val1.image_features.header.stamp.secs, val1.image_features.header.stamp.nsecs))
        length = len(val1.image_features.header.frame_id)
        #serialize val1.image_features.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.image_features.header.frame_id))
        #serialize val1.image_features.object_points
        length = len(val1.image_features.object_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.image_features.object_points:
          buff.write(struct.pack('<3f', val3.x, val3.y, val3.z))
        #serialize val1.image_features.image_points
        length = len(val1.image_features.image_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.image_features.image_points:
          buff.write(struct.pack('<2f', val3.x, val3.y))
        buff.write(struct.pack('<B', val1.image_features.success))
        buff.write(struct.pack('<I', val1.joint_features.header.seq))
        buff.write(struct.pack('<2I', val1.joint_features.header.stamp.secs, val1.joint_features.header.stamp.nsecs))
        length = len(val1.joint_features.header.frame_id)
        #serialize val1.joint_features.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_features.header.frame_id))
        #serialize val1.joint_features.object_points
        length = len(val1.joint_features.object_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.joint_features.object_points:
          buff.write(struct.pack('<3f', val3.x, val3.y, val3.z))
        #serialize val1.joint_features.joint_points
        length = len(val1.joint_features.joint_points)
        buff.write(struct.pack('<I', length))
        for val3 in val1.joint_features.joint_points:
          buff.write(struct.pack('<I', val3.header.seq))
          buff.write(struct.pack('<2I', val3.header.stamp.secs, val3.header.stamp.nsecs))
          length = len(val3.header.frame_id)
          #serialize val3.header.frame_id
          buff.write(struct.pack('<I%ss'%length, length, val3.header.frame_id))
          #serialize val3.name
          length = len(val3.name)
          buff.write(struct.pack('<I', length))
          for val4 in val3.name:
            length = len(val4)
            #serialize val4
            buff.write(struct.pack('<I%ss'%length, length, val4))
          #serialize val3.position
          length = len(val3.position)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(val3.position.tostring())
          #serialize val3.velocity
          length = len(val3.velocity)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(val3.velocity.tostring())
          #serialize val3.effort
          length = len(val3.effort)
          buff.write(struct.pack('<I', length))
          pattern = '<%sd'%length
          buff.write(val3.effort.tostring())
      #serialize self.M_chain
      length = len(self.M_chain)
      buff.write(struct.pack('<I', length))
      for val1 in self.M_chain:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.chain_id)
        #serialize val1.chain_id
        buff.write(struct.pack('<I%ss'%length, length, val1.chain_id))
        buff.write(struct.pack('<I', val1.chain_state.header.seq))
        buff.write(struct.pack('<2I', val1.chain_state.header.stamp.secs, val1.chain_state.header.stamp.nsecs))
        length = len(val1.chain_state.header.frame_id)
        #serialize val1.chain_state.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.chain_state.header.frame_id))
        #serialize val1.chain_state.name
        length = len(val1.chain_state.name)
        buff.write(struct.pack('<I', length))
        for val3 in val1.chain_state.name:
          length = len(val3)
          #serialize val3
          buff.write(struct.pack('<I%ss'%length, length, val3))
        #serialize val1.chain_state.position
        length = len(val1.chain_state.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.chain_state.position.tostring())
        #serialize val1.chain_state.velocity
        length = len(val1.chain_state.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.chain_state.velocity.tostring())
        #serialize val1.chain_state.effort
        length = len(val1.chain_state.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.chain_state.effort.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.sample_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.sample_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.target_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.target_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.chain_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.chain_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.M_cam
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.M_cam = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.CameraMeasurement()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.camera_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.camera_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.image_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.image_points = []
        for i in xrange(0, length):
          val2 = calibration_msgs.msg.ImagePoint()
          start = end
          end += 8
          (val2.x, val2.y,) = struct.unpack('<2f',str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (val1.cam_info.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.cam_info.header.stamp.secs, val1.cam_info.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.cam_info.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.cam_info.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.cam_info.height, val1.cam_info.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 16
        (val1.cam_info.roi.x_offset, val1.cam_info.roi.y_offset, val1.cam_info.roi.height, val1.cam_info.roi.width,) = struct.unpack('<4I',str[start:end])
        #deserialize val1.cam_info.D
        start = end
        end += 40
        val1.cam_info.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=5)
        #deserialize val1.cam_info.K
        start = end
        end += 72
        val1.cam_info.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        #deserialize val1.cam_info.R
        start = end
        end += 72
        val1.cam_info.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        #deserialize val1.cam_info.P
        start = end
        end += 96
        val1.cam_info.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
        start = end
        end += 1
        (val1.verbose,) = struct.unpack('<B',str[start:end])
        val1.verbose = bool(val1.verbose)
        start = end
        end += 4
        (val1.image.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.image.header.stamp.secs, val1.image.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.image.height, val1.image.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image.encoding
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image.encoding,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 5
        (val1.image.is_bigendian, val1.image.step,) = struct.unpack('<BI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image.data
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image.data,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.image_rect.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.image_rect.header.stamp.secs, val1.image_rect.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_rect.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_rect.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.image_rect.height, val1.image_rect.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_rect.encoding
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_rect.encoding,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 5
        (val1.image_rect.is_bigendian, val1.image_rect.step,) = struct.unpack('<BI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_rect.data
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_rect.data,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.features.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.features.header.stamp.secs, val1.features.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.features.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.features.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.features.object_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.features.object_points = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point32()
          start = end
          end += 12
          (val3.x, val3.y, val3.z,) = struct.unpack('<3f',str[start:end])
          val1.features.object_points.append(val3)
        #deserialize val1.features.image_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.features.image_points = []
        for i in xrange(0, length):
          val3 = calibration_msgs.msg.ImagePoint()
          start = end
          end += 8
          (val3.x, val3.y,) = struct.unpack('<2f',str[start:end])
          val1.features.image_points.append(val3)
        start = end
        end += 1
        (val1.features.success,) = struct.unpack('<B',str[start:end])
        self.M_cam.append(val1)
      #deserialize self.M_laser
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.M_laser = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.LaserMeasurement()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_points = []
        for i in xrange(0, length):
          val2 = sensor_msgs.msg.JointState()
          start = end
          end += 4
          (val2.header.seq,) = struct.unpack('<I',str[start:end])
          start = end
          end += 8
          (val2.header.stamp.secs, val2.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2.header.frame_id
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2.header.frame_id,) = struct.unpack(pattern, str[start:end])
          #deserialize val2.name
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          val2.name = []
          for i in xrange(0, length):
            start = end
            end += 4
            (length,) = struct.unpack('<I',str[start:end])
            #deserialize val3
            pattern = '<%ss'%length
            start = end
            end += struct.calcsize(pattern)
            (val3,) = struct.unpack(pattern, str[start:end])
            val2.name.append(val3)
          #deserialize val2.position
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          #deserialize val2.velocity
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          #deserialize val2.effort
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val2.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          val1.joint_points.append(val2)
        start = end
        end += 1
        (val1.verbose,) = struct.unpack('<B',str[start:end])
        val1.verbose = bool(val1.verbose)
        start = end
        end += 4
        (val1.snapshot.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.snapshot.header.stamp.secs, val1.snapshot.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.snapshot.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.snapshot.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.snapshot.angle_min, val1.snapshot.angle_max, val1.snapshot.angle_increment, val1.snapshot.time_increment, val1.snapshot.range_min, val1.snapshot.range_max, val1.snapshot.readings_per_scan, val1.snapshot.num_scans,) = struct.unpack('<6f2I',str[start:end])
        #deserialize val1.snapshot.ranges
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.snapshot.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        #deserialize val1.snapshot.intensities
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.snapshot.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        #deserialize val1.snapshot.scan_start
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.snapshot.scan_start = []
        for i in xrange(0, length):
          val3 = roslib.rostime.Time()
          start = end
          end += 8
          (val3.secs, val3.nsecs,) = struct.unpack('<2I',str[start:end])
          val1.snapshot.scan_start.append(val3)
        start = end
        end += 4
        (val1.laser_image.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.laser_image.header.stamp.secs, val1.laser_image.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_image.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_image.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.laser_image.height, val1.laser_image.width,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_image.encoding
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_image.encoding,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 5
        (val1.laser_image.is_bigendian, val1.laser_image.step,) = struct.unpack('<BI',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.laser_image.data
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.laser_image.data,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.image_features.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.image_features.header.stamp.secs, val1.image_features.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.image_features.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.image_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.image_features.object_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.image_features.object_points = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point32()
          start = end
          end += 12
          (val3.x, val3.y, val3.z,) = struct.unpack('<3f',str[start:end])
          val1.image_features.object_points.append(val3)
        #deserialize val1.image_features.image_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.image_features.image_points = []
        for i in xrange(0, length):
          val3 = calibration_msgs.msg.ImagePoint()
          start = end
          end += 8
          (val3.x, val3.y,) = struct.unpack('<2f',str[start:end])
          val1.image_features.image_points.append(val3)
        start = end
        end += 1
        (val1.image_features.success,) = struct.unpack('<B',str[start:end])
        start = end
        end += 4
        (val1.joint_features.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.joint_features.header.stamp.secs, val1.joint_features.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_features.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_features.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_features.object_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_features.object_points = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point32()
          start = end
          end += 12
          (val3.x, val3.y, val3.z,) = struct.unpack('<3f',str[start:end])
          val1.joint_features.object_points.append(val3)
        #deserialize val1.joint_features.joint_points
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_features.joint_points = []
        for i in xrange(0, length):
          val3 = sensor_msgs.msg.JointState()
          start = end
          end += 4
          (val3.header.seq,) = struct.unpack('<I',str[start:end])
          start = end
          end += 8
          (val3.header.stamp.secs, val3.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val3.header.frame_id
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val3.header.frame_id,) = struct.unpack(pattern, str[start:end])
          #deserialize val3.name
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          val3.name = []
          for i in xrange(0, length):
            start = end
            end += 4
            (length,) = struct.unpack('<I',str[start:end])
            #deserialize val4
            pattern = '<%ss'%length
            start = end
            end += struct.calcsize(pattern)
            (val4,) = struct.unpack(pattern, str[start:end])
            val3.name.append(val4)
          #deserialize val3.position
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          #deserialize val3.velocity
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          #deserialize val3.effort
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          val1.joint_features.joint_points.append(val3)
        self.M_laser.append(val1)
      #deserialize self.M_chain
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.M_chain = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ChainMeasurement()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.chain_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.chain_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.chain_state.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.chain_state.header.stamp.secs, val1.chain_state.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.chain_state.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.chain_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.chain_state.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.chain_state.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val3
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val3,) = struct.unpack(pattern, str[start:end])
          val1.chain_state.name.append(val3)
        #deserialize val1.chain_state.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.chain_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.chain_state.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.chain_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.chain_state.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.chain_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.M_chain.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

