/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/laser_cb_detector/msg/ConfigGoal.msg.  Do not edit! */
#ifndef LASER_CB_DETECTOR_CONFIGGOAL_H
#define LASER_CB_DETECTOR_CONFIGGOAL_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace laser_cb_detector
{

//! \htmlinclude ConfigGoal.msg.html

class ConfigGoal : public ros::Message
{
public:
  typedef boost::shared_ptr<ConfigGoal> Ptr;
  typedef boost::shared_ptr<ConfigGoal const> ConstPtr;

  typedef uint32_t _num_x_type;
  typedef uint32_t _num_y_type;
  typedef float _spacing_x_type;
  typedef float _spacing_y_type;
  typedef float _width_scaling_type;
  typedef float _height_scaling_type;
  typedef float _min_intensity_type;
  typedef float _max_intensity_type;
  typedef uint32_t _subpixel_window_type;
  typedef int32_t _subpixel_zero_zone_type;
  typedef uint8_t _flip_horizontal_type;

  uint32_t num_x;
  uint32_t num_y;
  float spacing_x;
  float spacing_y;
  float width_scaling;
  float height_scaling;
  float min_intensity;
  float max_intensity;
  uint32_t subpixel_window;
  int32_t subpixel_zero_zone;
  uint8_t flip_horizontal;

  ConfigGoal() : ros::Message(),
    num_x(0),
    num_y(0),
    spacing_x(0),
    spacing_y(0),
    width_scaling(0),
    height_scaling(0),
    min_intensity(0),
    max_intensity(0),
    subpixel_window(0),
    subpixel_zero_zone(0),
    flip_horizontal(0)
  {
  }
  ConfigGoal(const ConfigGoal &copy) : ros::Message(),
    num_x(copy.num_x),
    num_y(copy.num_y),
    spacing_x(copy.spacing_x),
    spacing_y(copy.spacing_y),
    width_scaling(copy.width_scaling),
    height_scaling(copy.height_scaling),
    min_intensity(copy.min_intensity),
    max_intensity(copy.max_intensity),
    subpixel_window(copy.subpixel_window),
    subpixel_zero_zone(copy.subpixel_zero_zone),
    flip_horizontal(copy.flip_horizontal)
  {
    (void)copy;
  }
  ConfigGoal &operator =(const ConfigGoal &copy)
  {
    if (this == &copy)
      return *this;
    num_x = copy.num_x;
    num_y = copy.num_y;
    spacing_x = copy.spacing_x;
    spacing_y = copy.spacing_y;
    width_scaling = copy.width_scaling;
    height_scaling = copy.height_scaling;
    min_intensity = copy.min_intensity;
    max_intensity = copy.max_intensity;
    subpixel_window = copy.subpixel_window;
    subpixel_zero_zone = copy.subpixel_zero_zone;
    flip_horizontal = copy.flip_horizontal;
    return *this;
  }
  virtual ~ConfigGoal() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("laser_cb_detector/ConfigGoal"); }
  inline static std::string __s_getMD5Sum() { return std::string("d592564bc71ebb8458e3d0d3a079d731"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "uint32 num_x     # Number of checkerboard corners in the X direction\n"
    "uint32 num_y     # Number of corners in the Y direction\n"
    "float32 spacing_x  # Spacing between corners in the X direction (meters)\n"
    "float32 spacing_y  # Spacing between corners in the Y direction (meters)\n"
    "\n"
    "# Specify how many times we want to upsample the image.\n"
    "#  This is often useful for detecting small checkerboards far away\n"
    "float32 width_scaling\n"
    "float32 height_scaling\n"
    "\n"
    "# Specifiy how intensity maps into a uint8. A specified window of\n"
    "#   intensities is linearly scaled to 0-255\n"
    "float32 min_intensity\n"
    "float32 max_intensity\n"
    "\n"
    "# Configure openCV's subpixel corner detector\n"
    "uint32 subpixel_window\n"
    "int32  subpixel_zero_zone\n"
    "\n"
    "# Specify if we need to flip snapshot image model. This is usually necessary\n"
    "# when the laser scans from right to left, since this is the opposite of images,\n"
    "# which are normally indexed left to right\n"
    "uint8 flip_horizontal\n"
    "\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4; // num_x
    __l += 4; // num_y
    __l += 4; // spacing_x
    __l += 4; // spacing_y
    __l += 4; // width_scaling
    __l += 4; // height_scaling
    __l += 4; // min_intensity
    __l += 4; // max_intensity
    __l += 4; // subpixel_window
    __l += 4; // subpixel_zero_zone
    __l += 1; // flip_horizontal
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_x);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_y);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, spacing_x);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, spacing_y);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, width_scaling);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, height_scaling);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, min_intensity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_intensity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, subpixel_window);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, subpixel_zero_zone);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, flip_horizontal);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_x);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_y);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, spacing_x);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, spacing_y);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, width_scaling);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, height_scaling);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, min_intensity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_intensity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, subpixel_window);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, subpixel_zero_zone);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, flip_horizontal);
    return read_ptr;
  }
};

typedef boost::shared_ptr<ConfigGoal> ConfigGoalPtr;
typedef boost::shared_ptr<ConfigGoal const> ConfigGoalConstPtr;


}

#endif
