# autogenerated by genmsg_py from ConfigActionGoal.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg
import actionlib_msgs.msg
import laser_cb_detector.msg

class ConfigActionGoal(roslib.message.Message):
  _md5sum = "f6f8cb46e4d9ad5f8de5944ff7521a06"
  _type = "laser_cb_detector/ConfigActionGoal"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """
Header header
actionlib_msgs/GoalID goal_id
ConfigGoal goal

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: laser_cb_detector/ConfigGoal
uint32 num_x     # Number of checkerboard corners in the X direction
uint32 num_y     # Number of corners in the Y direction
float32 spacing_x  # Spacing between corners in the X direction (meters)
float32 spacing_y  # Spacing between corners in the Y direction (meters)

# Specify how many times we want to upsample the image.
#  This is often useful for detecting small checkerboards far away
float32 width_scaling
float32 height_scaling

# Specifiy how intensity maps into a uint8. A specified window of
#   intensities is linearly scaled to 0-255
float32 min_intensity
float32 max_intensity

# Configure openCV's subpixel corner detector
uint32 subpixel_window
int32  subpixel_zero_zone

# Specify if we need to flip snapshot image model. This is usually necessary
# when the laser scans from right to left, since this is the opposite of images,
# which are normally indexed left to right
uint8 flip_horizontal


"""
  __slots__ = ['header','goal_id','goal']
  _slot_types = ['Header','actionlib_msgs/GoalID','laser_cb_detector/ConfigGoal']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,goal_id,goal
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ConfigActionGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = laser_cb_detector.msg.ConfigGoal()
    else:
      self.header = roslib.msg._Header.Header()
      self.goal_id = actionlib_msgs.msg.GoalID()
      self.goal = laser_cb_detector.msg.ConfigGoal()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<2I', self.goal_id.stamp.secs, self.goal_id.stamp.nsecs))
      length = len(self.goal_id.id)
      #serialize self.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.goal_id.id))
      buff.write(struct.pack('<2I6fIiB', self.goal.num_x, self.goal.num_y, self.goal.spacing_x, self.goal.spacing_y, self.goal.width_scaling, self.goal.height_scaling, self.goal.min_intensity, self.goal.max_intensity, self.goal.subpixel_window, self.goal.subpixel_zero_zone, self.goal.flip_horizontal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = laser_cb_detector.msg.ConfigGoal()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.goal_id.stamp.secs, self.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 41
      (self.goal.num_x, self.goal.num_y, self.goal.spacing_x, self.goal.spacing_y, self.goal.width_scaling, self.goal.height_scaling, self.goal.min_intensity, self.goal.max_intensity, self.goal.subpixel_window, self.goal.subpixel_zero_zone, self.goal.flip_horizontal,) = struct.unpack('<2I6fIiB',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<2I', self.goal_id.stamp.secs, self.goal_id.stamp.nsecs))
      length = len(self.goal_id.id)
      #serialize self.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.goal_id.id))
      buff.write(struct.pack('<2I6fIiB', self.goal.num_x, self.goal.num_y, self.goal.spacing_x, self.goal.spacing_y, self.goal.width_scaling, self.goal.height_scaling, self.goal.min_intensity, self.goal.max_intensity, self.goal.subpixel_window, self.goal.subpixel_zero_zone, self.goal.flip_horizontal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = laser_cb_detector.msg.ConfigGoal()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.goal_id.stamp.secs, self.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 41
      (self.goal.num_x, self.goal.num_y, self.goal.spacing_x, self.goal.spacing_y, self.goal.width_scaling, self.goal.height_scaling, self.goal.min_intensity, self.goal.max_intensity, self.goal.subpixel_window, self.goal.subpixel_zero_zone, self.goal.flip_horizontal,) = struct.unpack('<2I6fIiB',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

