# autogenerated by genmsg_py from ConfigGoal.msg. Do not edit.
import roslib.message
import struct


class ConfigGoal(roslib.message.Message):
  _md5sum = "d592564bc71ebb8458e3d0d3a079d731"
  _type = "laser_cb_detector/ConfigGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint32 num_x     # Number of checkerboard corners in the X direction
uint32 num_y     # Number of corners in the Y direction
float32 spacing_x  # Spacing between corners in the X direction (meters)
float32 spacing_y  # Spacing between corners in the Y direction (meters)

# Specify how many times we want to upsample the image.
#  This is often useful for detecting small checkerboards far away
float32 width_scaling
float32 height_scaling

# Specifiy how intensity maps into a uint8. A specified window of
#   intensities is linearly scaled to 0-255
float32 min_intensity
float32 max_intensity

# Configure openCV's subpixel corner detector
uint32 subpixel_window
int32  subpixel_zero_zone

# Specify if we need to flip snapshot image model. This is usually necessary
# when the laser scans from right to left, since this is the opposite of images,
# which are normally indexed left to right
uint8 flip_horizontal


"""
  __slots__ = ['num_x','num_y','spacing_x','spacing_y','width_scaling','height_scaling','min_intensity','max_intensity','subpixel_window','subpixel_zero_zone','flip_horizontal']
  _slot_types = ['uint32','uint32','float32','float32','float32','float32','float32','float32','uint32','int32','uint8']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   num_x,num_y,spacing_x,spacing_y,width_scaling,height_scaling,min_intensity,max_intensity,subpixel_window,subpixel_zero_zone,flip_horizontal
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ConfigGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.num_x is None:
        self.num_x = 0
      if self.num_y is None:
        self.num_y = 0
      if self.spacing_x is None:
        self.spacing_x = 0.
      if self.spacing_y is None:
        self.spacing_y = 0.
      if self.width_scaling is None:
        self.width_scaling = 0.
      if self.height_scaling is None:
        self.height_scaling = 0.
      if self.min_intensity is None:
        self.min_intensity = 0.
      if self.max_intensity is None:
        self.max_intensity = 0.
      if self.subpixel_window is None:
        self.subpixel_window = 0
      if self.subpixel_zero_zone is None:
        self.subpixel_zero_zone = 0
      if self.flip_horizontal is None:
        self.flip_horizontal = 0
    else:
      self.num_x = 0
      self.num_y = 0
      self.spacing_x = 0.
      self.spacing_y = 0.
      self.width_scaling = 0.
      self.height_scaling = 0.
      self.min_intensity = 0.
      self.max_intensity = 0.
      self.subpixel_window = 0
      self.subpixel_zero_zone = 0
      self.flip_horizontal = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2I6fIiB', self.num_x, self.num_y, self.spacing_x, self.spacing_y, self.width_scaling, self.height_scaling, self.min_intensity, self.max_intensity, self.subpixel_window, self.subpixel_zero_zone, self.flip_horizontal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 41
      (self.num_x, self.num_y, self.spacing_x, self.spacing_y, self.width_scaling, self.height_scaling, self.min_intensity, self.max_intensity, self.subpixel_window, self.subpixel_zero_zone, self.flip_horizontal,) = struct.unpack('<2I6fIiB',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2I6fIiB', self.num_x, self.num_y, self.spacing_x, self.spacing_y, self.width_scaling, self.height_scaling, self.min_intensity, self.max_intensity, self.subpixel_window, self.subpixel_zero_zone, self.flip_horizontal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 41
      (self.num_x, self.num_y, self.spacing_x, self.spacing_y, self.width_scaling, self.height_scaling, self.min_intensity, self.max_intensity, self.subpixel_window, self.subpixel_zero_zone, self.flip_horizontal,) = struct.unpack('<2I6fIiB',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

